<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_miniorange_dirsync
 *
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
/**
 * AccountSetup Controller
 *
 * @package     Joomla.Administrator
 * @subpackage  com_miniorange_dirsync
 * @since       0.0.9
 */
defined('_JEXEC') or die('Restricted access');
JHtml::_('script', JUri::base() . 'components/com_miniorange_dirsync/assets/js/jquery.1.11.0.min.js');
JHtml::_('script', JUri::base() . 'components/com_miniorange_dirsync/assets/js/utilityjs.js');
JHtml::_('stylesheet', JURI::base() .'components/com_miniorange_dirsync/assets/css/miniorange_boot.css');
JHtml::_('stylesheet', JURI::base() .'components/com_miniorange_dirsync/assets/css/miniorange_license.css');

class MiniorangeDirsyncControllerAccountsetup extends JControllerForm
{
	function __construct()
	{
		$this->view_list='accountsetup';
		parent::__construct();
	}

	public function moLdapSavelogin()
	{
		$user=JFactory::getUser();
		//CHECKING THE USER PERMISSIONS
		if ($user->authorise('core.edit', 'com_miniorange_dirsync')){
			$post=JFactory::getApplication()->input->post->getArray();
			$database_name='#__miniorange_dirsync_config';
			if($post==NULL)
				$ldap_login="";
			else 
				$ldap_login=$post['mo_ldap_login'];
	
			$updatefieldsarray=array(

				'ldap_login'=> $ldap_login,
			);

			MoLdapUtility::moLdapUpdateData($database_name, $updatefieldsarray,array('id'=>'1'));

			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=signinsettings', JText::_('COM_MINIORANGE_ENABLE_LOGIN_SAVED'));
		}else{
			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=signinsettings',JText::_('COM_MINIORANGE_MULTI_NO_PERMISSION_TO_SAVE'),'error');	
		}
	}	

	public function moLdapAttributeMapping()
	{
		$user=JFactory::getUser();
		//CHECKING THE USER PERMISSIONS
		if ($user->authorise('core.edit', 'com_miniorange_dirsync')){

			$post=JFactory::getApplication()->input->post->getArray();

			$username=isset($post['username']) 	? $post['username'] 	: '';
			$email=isset($post['email']) 	? $post['email'] 		: '';
			$name=isset($post['name_attr']) ? $post['name_attr'] 	: '';

			if($username=='' || $email=='' || $name=='')
			{
				$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=attributerolemapping', JText::_('COM_MINIORANGE_EMPTY_ATTRIBUTE_MAPPING'));
				return;
			}
			else{


				$database_name='#__miniorange_dirsync_config';
				$updatefieldsarray=array(
					'username'=> $username,
					'email'=> $email,
					'name'=> $name,
					'ldap_login'=> 'ch',
				);

				MoLdapUtility::moLdapUpdateData($database_name, $updatefieldsarray,array('id'=>'1'));
				$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=attributerolemapping', JText::_('COM_MINIORANGE_ATTRIBUTE_MAPPING_SAVED_SUCCESSFULLY'));
			}
		}else{
			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=attributerolemapping',JText::_('COM_MINIORANGE_MULTI_NO_PERMISSION_TO_SAVE'),'error');
		}
	}


public function moLdapSaveUserMapping($user_attributes, $ldap_attributes){
		
	$attribute_mapping=array();
	foreach($user_attributes as $key=> $value){
		
		$trimmed_value=trim($value);
		$trimed_key=trim($key);
		if(!empty($trimmed_value))
		{
			$ldap_attr_value=$ldap_attributes[$trimed_key];
			$trimmed_ia_value=trim($ldap_attr_value);
			if(!empty($trimmed_ia_value))
			{
				$anArray=array();
				$anArray['attr_name']=$trimmed_value;
				$anArray['attr_value']=$trimmed_ia_value;
				array_push($attribute_mapping, $anArray);
			}
		}
	}	

	$user_attribute_not_null=array();
	for($i=0; $i <=count($user_attributes)-1; $i++){
		if($user_attributes[$i]!=""){
			array_push($user_attribute_not_null, $user_attributes[$i]);
		}
	}

	if(count($user_attribute_not_null) !=1){
		$user_attributes_count=count($user_attribute_not_null);
		for($i=0; $i <=$user_attributes_count-1; $i++)
		{
			$search_value=$user_attribute_not_null[$i];
			for($j=$i+1; $j<$user_attributes_count; $j++){
				$check=strcmp(trim($search_value), trim($user_attribute_not_null[$j]));
				if($check==0)
				{
					return FALSE;
				}
			}
		}	  
	}
	
	$attribute_mapping=json_encode($attribute_mapping);
	return $attribute_mapping;	

}

public function moLdapProfilemapping(){

	$post=JFactory::getApplication()->input->post->getArray();
	$validatefilter=JFilterInput::getInstance();
	$user=JFactory::getUser();
	
	//CHECKING THE USER PERMISSIONS
	if ($user->authorise('core.edit', 'com_miniorange_dirsync')){
	
		$user_attributes=array_key_exists('user_profile_attr_name', $post)  ? $validatefilter->clean($post['user_profile_attr_name'], 'string') 	: array();
		$ldap_attributes=array_key_exists('user_profile_attr_value', $post) ? $validatefilter->clean($post['user_profile_attr_value'], 'string') 	: array();
		$attribute_mapping=$this->moLdapSaveUserMapping($user_attributes, $ldap_attributes);

		if($attribute_mapping==FALSE){
			$message=JText::_('COM_MINIORANGE_DUPLICATE_USER_PROFILE_ATTRIBUTES1').htmlspecialchars($user_attributes[0]).JText::_('COM_MINIORANGE_DUPLICATE_USER_PROFILE_ATTRIBUTES2'); 
			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=premium_features',$message, 'error');
			return;
		}
		else{

			$database_name='#__miniorange_dirsync_config';
			$updatefieldsarray=array(
		
				'user_profile_attributes'=> $attribute_mapping,
			);

			MoLdapUtility::moLdapUpdateData($database_name, $updatefieldsarray,array('id'=>'1'));
			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=premium_features',JText::_('COM_MINIORANGE_USER_PROFILE_ATTRIBUTE_MAPPING_SAVED_SUCCESSFULLY'));
			return;
		}
	}else{
		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=premium_features',JText::_('COM_MINIORANGE_MULTI_NO_PERMISSION_TO_SAVE'),'error');
	}
}

public function moLdapFieldmapping(){

	$post=JFactory::getApplication()->input->post->getArray();
	$validatefilter=JFilterInput::getInstance();
	$user=JFactory::getUser();
	
	//CHECKING THE USER PERMISSIONS
	if ($user->authorise('core.edit', 'com_miniorange_dirsync')){

		$user_attributes=array_key_exists('user_field_attr_name', $post)  ?  $validatefilter->clean($post['user_field_attr_name'], 'string') 	: array();
		$ldap_attributes=array_key_exists('user_field_attr_value', $post) ?  $validatefilter->clean($post['user_field_attr_value'], 'string') 	: array();
		$attribute_mapping=$this->moLdapSaveUserMapping($user_attributes, $ldap_attributes);

		if($attribute_mapping==FALSE){
			$message=JText::_('COM_MINIORANGE_DUPLICATE_USER_FIELD_ATTRIBUTES1').htmlspecialchars($user_attributes[0]).JText::_('COM_MINIORANGE_DUPLICATE_USER_FIELD_ATTRIBUTES2'); 
			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=premium_features',$message, 'error');
			return;
		}
		else{

			$database_name='#__miniorange_dirsync_config';
			$updatefieldsarray=array(
				
				'user_field_attributes'=> $attribute_mapping,
			);

			MoLdapUtility::moLdapUpdateData($database_name, $updatefieldsarray,array('id'=>'1'));
			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=premium_features',JText::_('COM_MINIORANGE_USER_FIELD_ATTRIBUTE_MAPPING_SAVED_SUCCESSFULLY'));
		}
	}else{
		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=premium_features',JText::_('COM_MINIORANGE_MULTI_NO_PERMISSION_TO_SAVE'),'error');
	}
}

public function moLdapSaveRolemapping1(){

	$post=JFactory::getApplication()->input->post->getArray();
	$user=JFactory::getUser();

	//CHECKING THE USER PERMISSIONS
	if ($user->authorise('core.edit', 'com_miniorange_dirsync')){
		
		$max_allowed_mappings=2;
		$added_mappings_count=2;
		$role_mapping_role=array();
		$role_mapping_groupname=array();
		$j=1;
		for ($i=1; $i <=$max_allowed_mappings; $i++) {
			if (isset($post['mapping_key_' . $i]) && $post['mapping_key_' . $i]) {
				if ($post['mapping_key_' . $i]=="")
					continue;

				$role_mapping_role[$j]=trim($post['mapping_key_'.$i]);				
				$role_mapping_groupname[$j]=trim($post['mapping_value_'.$i]);
				$j++;
			} else {
				break;
			}
		}

		$role_mapping_role=json_encode($role_mapping_role);
		$role_mapping_groupname=json_encode($role_mapping_groupname);

		$database_name='#__miniorange_ldap_role_mapping';
		$updatefieldsarray=array(
			'role_mapping_count'=> $added_mappings_count,
			'role_mapping_key_value'=> $role_mapping_role,
			'role_mapping_groupvalue'=> $role_mapping_groupname,
			'role_mapping_count'=> $added_mappings_count,
		);

		MoLdapUtility::moLdapUpdateData($database_name, $updatefieldsarray,array('id'=>'1'));
		$result=MoLdapUtility::moLdapFetchData('#__miniorange_ldap_role_mapping',array('id'=>'1'),'loadAssoc');
		

		$enable_role_mapping=$result['enable_ldap_role_mapping'];

		$statusMessage='';
		if (!$enable_role_mapping)
			$statusMessage=JText::_('COM_MINIORANGE_CHECK_ENABLE_GROUP_MAPPING');
			$message=JText::_('COM_MINIORANGE_GROUP_MAPPING_UPDATED');
		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=premium_features', $message . $statusMessage);
	}else{
		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=premium_features',JText::_('COM_MINIORANGE_MULTI_NO_PERMISSION_TO_SAVE'),'error');
	}
}
	
public function moLdapSaveRolemapping()
{
	$user=JFactory::getUser();

	//CHECKING THE USER PERMISSIONS
	if ($user->authorise('core.edit', 'com_miniorange_dirsync')){
		
		$post=JFactory::getApplication()->input->post->getArray();
		
		$database_name='#__miniorange_ldap_role_mapping';
		$updatefieldsarray=array(
			'mapping_value_default'=> isset($post['mapping_value_default'])  ? $post['mapping_value_default'] : '',
			'enable_ldap_role_mapping'=> isset($post['enable_role_mapping']) 	? $post['enable_role_mapping'] 	 : '0',

		);

		MoLdapUtility::moLdapUpdateData($database_name, $updatefieldsarray,array('id'=>'1'));

		$result=MoLdapUtility::moLdapFetchData('#__miniorange_ldap_role_mapping',array('id'=>'1'),'loadAssoc');

		$enable_role_mapping=$result['enable_ldap_role_mapping'];

		$statusMessage='';
		if (!$enable_role_mapping)
			$statusMessage=JText::_('COM_MINIORANGE_CHECK_ENABLE_GROUP_MAPPING');
			$message=JText::_('COM_MINIORANGE_GROUP_MAPPING_UPDATED');
		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=rolemapping', $message . $statusMessage);
	}else{
		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=rolemapping',JText::_('COM_MINIORANGE_MULTI_NO_PERMISSION_TO_SAVE'),'error');
	}
}

function moLdapSaveConfig()
{
	$validatefilter=JFilterInput::getInstance();
	$user=JFactory::getUser();

	//CHECKING THE USER PERMISSIONS
	if ($user->authorise('core.edit', 'com_miniorange_dirsync')){

		$post=JFactory::getApplication()->input->post->getArray();
		$ldap_configuration_option=isset($post['ldap_configuration_action']) 	? $post['ldap_configuration_action'] 									: '';
		$ldap_server_url=isset($post['mo_ldap_server_url']) 			? trim($validatefilter->clean($post['mo_ldap_server_url'], 'string'))  	: '';
		$service_account_dn=isset($post['service_account_dn']) 			? trim($validatefilter->clean($post['service_account_dn'], 'string')) 	: '';
		$service_account_password=isset($post['service_account_password']) 		? $post['service_account_password'] 									: '';
		$mo_ldap_directory_server_type=isset($post['mo_ldap_directory_server_type']) ? $post['mo_ldap_directory_server_type'] 								: '';
		$ldap_type=isset($post['mo_ldap_type'])		? $post['mo_ldap_type'] 		: '';
		$ignore_ldaps=isset($post['mo_ignore_ldaps'])	? $post['mo_ignore_ldaps']	: '';
		$enable_tls = isset($post['mo_enable_tls']) ? $post['mo_enable_tls'] : '';
		
		if(!MoLdapUtility::mo_ldap_is_extension_installed('ldap')){
			$message=JText::_('COM_MINIORANGE_WARNING').' <a href="http://php.net/manual/en/curl.installation.php" target="_blank"> '.JText::_('COM_MINIORANGE_CURL_EXTENSION').'</a> '.JText::_('COM_MINIORANGE_CURL_EXTENSION_DISABLED');
			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', $message, 'error');
			return;
		}

		if (empty($post['mo_ldap_port'])) {

			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_LDAP_PORT_CANNOT_BE_EMPTY'), 'error');
			return;
		}

		if (empty($post['mo_ldap_server_url'])) {

			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_LDAP_SERVER_URL_CANNOT_BE_EMPTY'), 'error');
			return;
		}

		if($ldap_type=='STARTTLS'){
			$ldap_server_url='ldap://' . $ldap_server_url . ':' . $post['mo_ldap_port'];
		}
		else{
			$ldap_server_url=$post['mo_ldap_type'] . '://' . $ldap_server_url . ':' . $post['mo_ldap_port'];
		}
		$ldap_server_url=MoLdapUtility::mo_ldap_encrypt($ldap_server_url);

		if ($ldap_configuration_option=='ping_ldap_server') {

			$status=MoLdapConfig::mo_ldap_ping_ldap_server($ldap_server_url, null, null, $ignore_ldaps, $enable_tls);
		
			if ($status=="SUCCESS") {

				$database_name='#__miniorange_dirsync_config';
				$updatefieldsarray=array(
					'ldap_server_url'=> $ldap_server_url,
					'mo_ldap_directory_server_type'=> $mo_ldap_directory_server_type,
					'enable_dirsync_scheduler'=> $ignore_ldaps,	
					'enable_tls' => $enable_tls,
				);

				////NEED TO ADD DEFAULT SEARCH BASE

				MoLdapUtility::moLdapUpdateData($database_name, $updatefieldsarray,array('id'=>'1'));

				$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_CONNECTED_TO_AD_CONFIGURE_SERVICE_ACCOUNT'));
				return;
			} else {
			
				$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_CONNECTION_FAILED'), 'error');
			}
			return;
		}
	
		if (empty($service_account_dn) || empty($service_account_password)) {

			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_FILL_SERVICE_ACCOUNT_DETAILS'), 'error');
			return;
		}

		$service_account_dn=MoLdapUtility::mo_ldap_encrypt($service_account_dn);
		$service_account_password=MoLdapUtility::mo_ldap_encrypt($service_account_password);
		$status=MoLdapConfig::mo_ldap_ping_ldap_server($ldap_server_url, $service_account_dn, $service_account_password,$ignore_ldaps, $enable_tls);
	
		if ("SUCCESS" !==$status) {
			
			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_CONNECTION_SUCCESSFUL_VERIFY_SERVICE_ACCOUNT'), 'error');
			return;
		}

		$base_dn = MoLdapConfig::mo_ldap_get_base_dn($ldap_server_url, $service_account_dn, $service_account_password,$ignore_ldaps, $enable_tls);
		if($base_dn != 'ERROR') $search_base = $base_dn;
		else $search_base = "";
		
		$database_name='#__miniorange_dirsync_config';
		$updatefieldsarray=array(
			'ldap_server_url'=> $ldap_server_url,
			'service_account_dn'=> $service_account_dn,
			'service_account_password'=> $service_account_password,
			'mo_ldap_directory_server_type'=> $mo_ldap_directory_server_type,
			'enable_dirsync_scheduler'=> $ignore_ldaps,
			'enable_tls' => $enable_tls,
			'search_base' => MoLdapUtility::mo_ldap_encrypt($search_base),
		);

		MoLdapUtility::moLdapUpdateData($database_name, $updatefieldsarray,array('id'=>'1'));

		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_CONNECTION_SUCCESSFUL_CONFIGURE_SEARCH_BASE'));
	}else{
		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration',JText::_('COM_MINIORANGE_MULTI_NO_PERMISSION_TO_SAVE'),'error');
	}
}

function moLdapSaveUserMappingConfig()
{
	$validatefilter=JFilterInput::getInstance();
	$user=JFactory::getUser();

	//CHECKING THE USER PERMISSIONS
	if ($user->authorise('core.edit', 'com_miniorange_dirsync')){

		$post=JFactory::getApplication()->input->post->getArray();
		$search_base_string=isset($post['search_base'])   ? $validatefilter->clean($post['search_base'], 'string')   : '';
		$search_filter=isset($post['search_filter']) ? $validatefilter->clean($post['search_filter'], 'string') : '';
	
		if (empty($search_base_string) || empty($search_filter)) {
			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_FILL_SEARCH_BASE_SEARCH_FILTER'), 'error');
			return;
		}

		$search_base_string=MoLdapUtility::mo_ldap_encrypt($search_base_string);
		$database_name='#__miniorange_dirsync_config';
		$updatefieldsarray=array(
			'search_base'=> $search_base_string,
			'search_filter'=> $search_filter,
		);
		MoLdapUtility::moLdapUpdateData($database_name, $updatefieldsarray,array('id'=>'1'));

		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_USER_MAPPING_SAVED_SUCCESSFULLY'));
	}else{
		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration',JText::_('COM_MINIORANGE_MULTI_NO_PERMISSION_TO_SAVE'),'error');
	}
}

function moLdapTestAttributeMapping()
{
	$user=JFactory::getUser();

	//CHECKING THE USER PERMISSIONS
	if ($user->authorise('core.edit', 'com_miniorange_dirsync')){
		
		$result=MoLdapUtility::moLdapFetchData('#__miniorange_dirsync_config',array('id'=>'1'),'loadAssoc');
		
		if (empty($result['search_base']) || empty($result['search_filter'])) {

			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_FILL_SEARCH_BASE_SEARCH_FILTER'), 'error');
			return;
		}
		
		$search_base=MoLdapUtility::mo_ldap_decrypt($result['search_base']);
		$get=JFactory::getApplication()->input->get->getArray();
	
		$username=isset($get['test_username_attr']) ? trim($get['test_username_attr']) : '';
		echo '	<style>
			.mo_ldap_test_unsuccessful{color: white;background-color: #e06d6d; padding:2%;margin-bottom:20px;text-align:center; border:1px solid #AEDB9A; font-size:18pt;}
			.mo_ldap_test_unsuccessful_details{margin-left:10px;padding:10px;border: 1px solid black;text-align:center}
		</style>';

		if (empty($username)) {

			?><div class="mo_ldap_test_unsuccessful"><?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL');?></div>
			
			<div class="mo_ldap_test_unsuccessful_details">
				<?php echo JText::_('COM_MINIORANGE_ENTER_USERNAME')?>
			</div><?php
			exit;
		}

		$auth_response=MoLdapConfig::mo_ldap_search_user_attributes(trim($username));

		if (!$auth_response) {
			?><div class="mo_ldap_test_unsuccessful"><?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL');?></div>
			
			<div class="mo_ldap_test_unsuccessful_details">
				<?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS1').$username.JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS2').$username.JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS3').$result['search_filter'].JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS4').$search_base.JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS5');?>
			
			</div><?php
			exit;
		}
		elseif($auth_response->statusMessage=="USER_NOT_EXIST"){
			?><div class="mo_ldap_test_unsuccessful"><?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL');?></div>
			
			<div class="mo_ldap_test_unsuccessful_details">
			<?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS1').$username.JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS2').$username.JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS3').$result['search_filter'].JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS4').$search_base.JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS5');?>
			</div><?php
			exit;
		}
		else if($auth_response->statusMessage=="BAD_SEARCH_FILTER"){
			?><div class="mo_ldap_test_unsuccessful"><?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL');?></div>
			
			<div class="mo_ldap_test_unsuccessful_details">
				<p><?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_CHECK_USERNAME1').$username.JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_CHECK_USERNAME2');?></p>
			</div><?php
			exit;
		}
		else if($auth_response->statusMessage=="LDAP_NOT_RESPONDING"){
			?><div class="mo_ldap_test_unsuccessful"><?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL');?></div>
			
			<div class="mo_ldap_test_unsuccessful_details">
				<p><?php echo JText::_('COM_MINIORANGE_LDAP_NOT_RESPONDING');?></p>
			</div><?php
			exit;
		}else if(empty($auth_response->statusMessage)){
			?><div class="mo_ldap_test_unsuccessful"><?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL');?></div>
			
			<div class="mo_ldap_test_unsuccessful_details">
				<?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS1').$username.JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS2').$username.JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS3').$result['search_filter'].JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS4').$search_base.JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS5');?>
			
			</div><?php
			exit;
		}
	
		?>

		<style>
			table {border-collapse: collapse;}
			table,th,td {border: 1px solid black;}
			td {padding: 5px;}
			.mo_ldap_attr_table_row{font-weight:bold;border:2px solid #949090;padding:2%}
			.mo_ldap_attr_table_column{padding:2%;border:2px solid #949090; word-wrap:break-word;}
			.mo_ldap_attr_success_message{color: #3c763d;background-color: #dff0d8; padding:2%;margin-bottom:20px;text-align:center; border:1px solid #AEDB9A; font-size:18pt;}
		</style>
		<div class="mo_ldap_attr_success_message"><?php echo JText::_('COM_MINIORANGE_TEST_SUCCESSFUL');?></div>	
		<table style="width:80%;margin:auto;text-align:center">
			<tr style="text-align:center;" >
				<td colspan="2" class="mo_ldap_attr_table_row">
					<p style="font-weight:bold;font-size:14pt;margin-left:1%;"><?php echo JText::_('COM_MINIORANGE_ATTRIBUTE_RECIEVED');?></p>
				</td>
			</tr>
				
			<tr style="text-align:center;">
				<th class="mo_ldap_attr_table_row"><?php echo JText::_('COM_MINIORANGE_ATTRIBUTE_NAME');?></th>
				<th class="mo_ldap_attr_table_row"><?php echo JText::_('COM_MINIORANGE_ATTRIBUTE_VALUE');?></th>
			</tr>

			<?php
			error_reporting(E_ERROR | E_PARSE);
			$attribute_List = array();
			foreach ($auth_response->attributeList as $attribute=> $key) {
				array_push($attribute_List, $attribute);
				?><tr class="mo_ldap_attr_table_row"><?php 
				if($attribute=='thumbnailphoto'){?>
					<td class="mo_ldap_attr_table_column" style="width:60px!important"><strong><?php echo $attribute; ?></strong></td>
					<td> <img src="<?php echo $key;?>" class="mo_boot_img-responsive mo_boot_img-rounded" style="height:67px !important;width:60px !important" alt="User image"></td>
				<?php continue;}?>
				<?php if ($attribute !='memberOf') { ?>
						<td class="mo_ldap_attr_table_column" style="width:60px !important"><strong><?php echo $attribute; ?></strong></td>
						<td style="width:100px !important"><?php print_r($key) ?></td>
				</tr>
				<?php
				} else {
					?><td class="mo_ldap_attr_table_column"><?php echo $attribute; ?></b></td>
						<td>
							<table>
								<?php if ($key !="not available")
									foreach ($key as $keyname=> $keyvalue) {
								?>
								<tr class="mo_ldap_attr_table_row">
									<td><?php echo $keyname; ?></td>
									<td> <?php echo $keyvalue; ?></td>
								</tr>
								<?php
								} ?>
							</table>
						</td>
					<?php
				}
			}
			?>
		</table>
		<?php

		$AdUserDetails = array_map('MoLdapUtility::convertBinaryToString', $auth_response->attributeList);
		$AdDateInJson = json_encode($AdUserDetails, JSON_UNESCAPED_SLASHES | JSON_PRETTY_PRINT);
		$user_details= array();
		$user_details['Name'] = $username;
		$user_details['Details'] = ($AdDateInJson);

		$database_name='#__miniorange_dirsync_config';
		$updatefieldsarray=array(
			'ad_attribute_list'=> json_encode($attribute_List),
			'ldap_login' => 'ch',
			'test_config_details'       => json_encode($user_details),	
		);
		MoLdapUtility::moLdapUpdateData($database_name, $updatefieldsarray,array('id'=>'1'));
		exit;
	}
}

function attributemappingresults(){
	
	$validatefilter=JFilterInput::getInstance();
	$user=JFactory::getUser();

	//CHECKING THE USER PERMISSIONS
	if ($user->authorise('core.edit', 'com_miniorange_dirsync')){
		
		$moLdapServerDetails=new MoLdapConstants;
		$usernameAttr=$moLdapServerDetails->getUsernameAttribute();
		$emailAttr=$moLdapServerDetails->getEmailAttribute();
		$nameAttr=$moLdapServerDetails->getNameAttribute();
		$user_field_attributes=$moLdapServerDetails->getFieldAttributes();	
		$user_profile_attributes=$moLdapServerDetails->getProfileAttributes();	

		if (empty($moLdapServerDetails->getSearchBase()) || empty($moLdapServerDetails->getSearchFilter())) {

			$message=JText::_('COM_MINIORANGE_FILL_SEARCH_BASE_SEARCH_FILTER');
			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', $message, 'error');
			return;
		}

		$get=JFactory::getApplication()->input->get->getArray();
	
		$username=isset($get['test_attribute_username']) ? $validatefilter->clean($get['test_attribute_username'], 'string')		: '';
		$password=isset($get['test_attribute_password']) ? $get['test_attribute_password'] 										: '';
		
		if (empty($username) || empty($password)) {

			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=attributerolemapping', JText::_('COM_MINIORANGE_USERNAME_PASSWORD_REQUIRED'), 'error');
			return;
		}

		$auth_response=MoLdapConfig::mo_ldap_authenticate_user(trim($username), $password);
		?>
			<style>.mo_ldap_test_premium_features{font-weight:bold;border:2px solid #949090;padding:2%;}
			.mo_ldap_test_unsuccessful{color:white;background-color: #e06d6d;padding:2%;margin-bottom:20px;text-align:center; border:1px solid #AEDB9A; font-size:18pt;}
			.mo_ldap_test_unsuccessful_message{margin-left:10px;padding:10px;border: 1px solid black;}
			</style>
		<?php
		if ($auth_response->statusMessage=="USER_NOT_EXIST") {
				
			$search_base=$moLdapServerDetails->getSearchBase();
			$search_filter=$moLdapServerDetails->getSearchFilter();
			$message=JText::_('COM_MINIORANGE_CANNOT_FIND_USER1').$username.JText::_('COM_MINIORANGE_CANNOT_FIND_USER2').$search_base.JText::_('COM_MINIORANGE_CANNOT_FIND_USER3').$search_filter.JText::_('COM_MINIORANGE_CANNOT_FIND_USER4').$search_base.JText::_('COM_MINIORANGE_CANNOT_FIND_USER5');
			?><div class="mo_ldap_test_unsuccessful"><?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL');?></div>
			
			<div class="mo_ldap_test_unsuccessful_message">
			<?php echo $message;?>
			</div><?php
			exit;
		} 
		
		else if ($auth_response->statusMessage=="LDAP_NOT_RESPONDING") {
			?><div class="mo_ldap_test_unsuccessful"><?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL');?></div>
			
			<div class="mo_ldap_test_unsuccessful_message">
			<?php echo JText::_('COM_MINIORANGE_LDAP_NOT_RESPONDING_CHECK_CONGIG');?>
			</div><?php
			exit;
		} 
		
		else if ($auth_response->statusMessage=="USER_PASSWORD_DOESNTMATCH") {
			?><div class="mo_ldap_test_unsuccessful"><?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL');?></div>
			
			<div class="mo_ldap_test_unsuccessful_message">
			<?php echo JText::_('COM_MINIORANGE_PASSWORD_MISMATCH');?>
			</div><?php
			exit;
		} 
		
		else if ($auth_response->statusMessage=="SUCCESS") {
			$mo_ldap_user_attributes=MoLdapConfig::mo_ldap_get_user_details($username);
			?>
		
			<?php

			echo "<div style='color: #3c763d;	background-color: #dff0d8;text-align:center; border:1px solid #AEDB9A;'><h3>".JText::_('COM_MINIORANGE_TEST_USER_ATTRIBUTE_MAPPING_DETAILS')."</h3></div>
				<div class='mo_boot_mx-4'>
					<p><strong>".JText::_('COM_MINIORANGE_TEST_USER_ATTRIBUTE_MAPPING_SUCCESSFULLY_AUTHENTICATED')." <span style='color:red'>".$username."</span></strong></p>
					<br>".JText::_('COM_MINIORANGE_TEST_USER_LOGIN_ATTRIBUTE_MAPPING_DETAILS')."
					<table style='width:80%;margin:auto;text-align:center'>
						<tr style='text-align:center;'>
							<th style='font-weight:bold;border:2px solid #949090;padding:2%;background-color:#d5d3cd'>".JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_USER_LOGIN_ATTRIBUTE_NAME')."</th>
							<th style='font-weight:bold;padding:2%;border:2px solid #949090; word-wrap:break-word;background-color:#d5d3cd'>".JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_USER_LOGIN_ATTRIBUTE_VALUE')."</th>
						</tr>";
					if(isset($usernameAttr) || isset($nameAttr) || isset($emailAttr)){
						$username=isset($mo_ldap_user_attributes[0][$usernameAttr][0]) ? $mo_ldap_user_attributes[0][$usernameAttr][0] : JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_RECHECK_VALUE');
						$name=isset($mo_ldap_user_attributes[0][$nameAttr][0]) ? $mo_ldap_user_attributes[0][$nameAttr][0] : JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_RECHECK_VALUE');
						$email=isset($mo_ldap_user_attributes[0][$emailAttr][0]) ? $mo_ldap_user_attributes[0][$emailAttr][0] : JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_RECHECK_VALUE');
						echo"<tr class='mo_ldap_test_premium_features'>
						<td class='mo_ldap_test_premium_features'>Username</td>
						<td class='mo_ldap_test_premium_features'>".$username."</td>
						</tr>
						<tr class='mo_ldap_test_premium_features'>
						<td class='mo_ldap_test_premium_features'>Name</td>
						<td class='mo_ldap_test_premium_features'>".$name."</td>
						</tr>
						<tr class='mo_ldap_test_premium_features'>
						<td class='mo_ldap_test_premium_features'>Email</td>
						<td class='mo_ldap_test_premium_features'>".$email."</td>
						</tr>
						</table><br>";
					}
				echo "<strong class='mo_boot_my-4' >".JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_NOTE')."</strong>
				<br><br>
				<div class='mo_boot_my-4' style='color: #black;	background-color: #d8e7f0; text-align:center; border:1px solid #9aa0db;'>
					<h4>".JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_USER_PROFILE_ATTRIBUTE')."</h4>
				</div>		
				<p>".JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_USER_PROFILE_ATTRIBUTE_DETAILS')."</p>
				<table style='width:80%;margin:auto;text-align:center'>
					<tr style='text-align:center;'>
						<th style='font-weight:bold;border:2px solid #949090;padding:2%;background-color:#d5d3cd'>".JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_USER_PROFILE_ATTRIBUTE_NAME')."</th>
						<th style='font-weight:bold;padding:2%;border:2px solid #949090; word-wrap:break-word;background-color:#d5d3cd'>".JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_USER_PROFILE_ATTRIBUTE_VALUE')."</th>
					</tr>";
					if(isset($user_profile_attributes[0]['attr_name'] )){
						$profile_value1=isset($mo_ldap_user_attributes[0][$user_profile_attributes[0]['attr_value']][0]) ? $mo_ldap_user_attributes[0][$user_profile_attributes[0]['attr_value']][0] : JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_RECHECK_VALUE');
						echo"<tr class='mo_ldap_test_premium_features'>
						<td class='mo_ldap_test_premium_features'>".$user_profile_attributes[0]['attr_name'] ."</td>
						<td class='mo_ldap_test_premium_features'>".$profile_value1."</td>
						</tr>";
						if(isset($user_profile_attributes[1]['attr_name'] )){
							$profile_value2=isset($mo_ldap_user_attributes[0][$user_profile_attributes[1]['attr_value']][0]) ? $mo_ldap_user_attributes[0][$user_profile_attributes[1]['attr_value']][0] : JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_RECHECK_VALUE');
							echo"<tr class='mo_ldap_test_premium_features'>
							<td class='mo_ldap_test_premium_features'>".$user_profile_attributes[1]['attr_name'] ."</td>
							<td class='mo_ldap_test_premium_features'>".$profile_value2."</td>
							</tr>";
						}
					}
					else{
						echo"<tr class='mo_ldap_test_premium_features'>
							<td class='mo_ldap_test_premium_features'>".JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_NOT_CONFIGURED')."</td>
							<td class='mo_ldap_test_premium_features'>".JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_NOT_CONFIGURED')."</td>
							</tr>";
						}
					echo"
				</table><br>
				<div class='mo_boot_my-4' style='color: black;background-color: #d8e7f0; text-align:center; border:1px solid #9aa0db;'>
					<h4>".JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_USER_FIELD_ATTRIBUTE')."</h4>
				</div>		
				<p>".JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_USER_FIELD_ATTRIBUTE_DETAILS')."</p>
				<table style='width:80%;margin:auto;text-align:center'>
					<tr style='text-align:center;'>
						<th style='font-weight:bold;border:2px solid #949090;padding:2%;background-color:#d5d3cd'>".JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_USER_FIELD_ATTRIBUTE_NAME')."</th>
						<th style='font-weight:bold;padding:2%;border:2px solid #949090; word-wrap:break-word;background-color:#d5d3cd'>".JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_USER_FIELD_ATTRIBUTE_VALUE')."</th>
					</tr>";
				

					if(isset($user_field_attributes[0]['attr_name'] )){
						$field_value1=isset($mo_ldap_user_attributes[0][$user_field_attributes[0]['attr_value']][0]) ? $mo_ldap_user_attributes[0][$user_field_attributes[0]['attr_value']][0] : JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_RECHECK_VALUE');
						echo"<tr class='mo_ldap_test_premium_features'>
						<td class='mo_ldap_test_premium_features'>".$user_field_attributes[0]['attr_name'] ."</td>
						<td class='mo_ldap_test_premium_features'>".$field_value1."</td>
						</tr>";
						if(isset($user_field_attributes[1]['attr_name'] )){
							$field_value2=isset($mo_ldap_user_attributes[0][$user_field_attributes[1]['attr_value']][0]) ?$mo_ldap_user_attributes[0][$user_field_attributes[1]['attr_value']][0]: JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_RECHECK_VALUE');
							echo"<tr class='mo_ldap_test_premium_features'>
							<td class='mo_ldap_test_premium_features'>".$user_field_attributes[1]['attr_name'] ."</td>
							<td class='mo_ldap_test_premium_features'>".$field_value2."</td>
							</tr>";
						}
					}
					else{
						echo"<tr class='mo_ldap_test_premium_features'>
							<td class='mo_ldap_test_premium_features'>".JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_NOT_CONFIGURED')."</td>
							<td class='mo_ldap_test_premium_features'>".JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING_NOT_CONFIGURED')."</td>
							</tr>";
					}
				echo"</table>
				<br><br>";

			$mo_ldap_default_role=$moLdapServerDetails->getMappingValueDefault();
			$mo_ldap_role_mapping_key_value=$moLdapServerDetails->getRoleMappingKeyValue();
			$mo_ldap_role_mapping_groupvalue=$moLdapServerDetails->getRoleMappingGroupValue();


			$mo_ldap_user_group_defined='group_not_found';
			$group_list=array();
			$mo_ldap_user_group_value=array();
			$mo_ldap_user_belongs_to_group=array();
		

			$i=1;
			if(gettype($mo_ldap_role_mapping_key_value)=='object'){
				foreach ($mo_ldap_role_mapping_key_value as $keys) {
					if (!empty($mo_ldap_user_attributes[0]['memberof']))
						if (in_array($keys, $mo_ldap_user_attributes[0]['memberof'])) {
							$mo_ldap_user_group_defined='group_found';
							array_push($mo_ldap_user_group_value, $mo_ldap_role_mapping_groupvalue[$i]);
					}
					$i++;		
				}
			}	
			
			if($mo_ldap_user_group_defined=='group_not_found'){
				array_push($mo_ldap_user_group_value,$mo_ldap_default_role);
			}

			for($j=0;$j<count($mo_ldap_user_group_value); $j++){
			switch($mo_ldap_user_group_value[$j]){
				case "2": $mo_ldap_user_belongs_to_group[$j]="Registered";
						array_push($group_list, $mo_ldap_user_belongs_to_group[$j]);
						break;
				case "3": $mo_ldap_user_belongs_to_group[$j]="Author";
						array_push($group_list, $mo_ldap_user_belongs_to_group[$j]);
						break;
				case "4": $mo_ldap_user_belongs_to_group[$j]="Editor";
						array_push($group_list, $mo_ldap_user_belongs_to_group[$j]); 
						break;
				case "5": $mo_ldap_user_belongs_to_group[$j]="Publisher";
						array_push($group_list, $mo_ldap_user_belongs_to_group[$j]);
						break;
				case "6": $mo_ldap_user_belongs_to_group[$j]="Manager";
						array_push($group_list, $mo_ldap_user_belongs_to_group[$j]);
						break;
				case "7": $mo_ldap_user_belongs_to_group[$j]="Administrator";
						array_push($group_list, $mo_ldap_user_belongs_to_group[$j]);
						break;
			}}
			echo "<div style='color: black;background-color: #d8e7f0; text-align:center; border:1px solid #9aa0db;'><h3>".JText::_('COM_MINIORANGE_TEST_GROUP_MAPPING_USER_GROUP_MAPPING_DETAILS')."</h3></div>
				<div class='mo_boot_mx-4'>
					<p><strong>".JText::_('COM_MINIORANGE_TEST_GROUP_MAPPING_SUCCESSFULLY_AUTHENTICATED')." <span style='color:red'>".$username."</span></strong></p>
					<br>".JText::_('COM_MINIORANGE_TEST_GROUP_MAPPING_DETAILS')."
				

				<table style='width:80%;margin:auto;text-align:center'>
					<tr style='text-align:center;'>
						<th style='font-weight:bold;border:2px solid #949090;padding:2%;background-color:#d5d3cd'>".JText::_('COM_MINIORANGE_TEST_GROUP_MAPPING_JOOMLA_SITE_ROLES')."</th>
					</tr>";
					if($group_list){
					for($i=0;$i<count($group_list);$i++){
					
						echo"<tr class='mo_ldap_test_premium_features'>
						<td class='mo_ldap_test_premium_features'>".$group_list[$i]."</td>
						</tr>";
					}}
					else{
						echo"<tr class='mo_ldap_test_premium_features'>
						<td class='mo_ldap_test_premium_features'>".JText::_('COM_MINIORANGE_TEST_GROUP_MAPPING_NOT_CONFIGURED')."</td>
						</tr>";
					}
				echo"</table></div>
			</div>";
			exit;
		}
		else {
			?><div class="mo_ldap_test_unsuccessful"><?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL');?></div>
			
			<div class="mo_ldap_test_unsuccessful_message">
			<?php echo JText::_('COM_MINIORANGE_LDAP_NOT_RESPONDING');?>
			</div><?php
			exit;
		}	

	}	
}

function testConfigurations()
{

	$validatefilter=JFilterInput::getInstance();
	$user=JFactory::getUser();

	//CHECKING THE USER PERMISSIONS
	if ($user->authorise('core.edit', 'com_miniorange_dirsync')){

		$result=MoLdapUtility::moLdapFetchData('#__miniorange_dirsync_config',array('id'=>'1'),'loadAssoc');
		if (empty($result['search_base']) || empty($result['search_filter'])) {

			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_FILL_SEARCH_BASE_SEARCH_FILTER'), 'error');
			return;
		}

		$post=JFactory::getApplication()->input->post->getArray();
		$username=isset($post['test_username']) ? $validatefilter->clean($post['test_username'], 'string') : '';
		$password=isset($post['test_password']) ? $post['test_password'] 									 : '';
	
		if (empty($username) || empty($password)) {

			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_USERNAME_PASSWORD_REQUIRED'), 'error');
			return;
		}

		//SAVE USERNAME
		$database_name='#__miniorange_dirsync_config';
		$updatefieldsarray=array(
			'ldap_test_username'=> $username,
		);
		MoLdapUtility::moLdapUpdateData($database_name, $updatefieldsarray,array('id'=>'1'));
		
		$auth_response=MoLdapConfig::mo_ldap_authenticate_user(trim($username), $password);

		if ($auth_response->statusMessage=="SUCCESS") {
			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=attributerolemapping', JText::_('COM_MINIORANGE_SUCCESSFUL_CONNECTED'));
		} 
		
		else if ($auth_response->statusMessage=="USER_NOT_EXIST") {

			$search_base=MoLdapUtility::mo_ldap_decrypt($result['search_base']);
			$search_filter=$result['search_filter'];
			$message=JText::_('COM_MINIORANGE_CANNOT_FIND_USER1').htmlspecialchars($username).JText::_('COM_MINIORANGE_CANNOT_FIND_USER2').htmlspecialchars($search_base).JText::_('COM_MINIORANGE_CANNOT_FIND_USER3').htmlspecialchars($search_filter).JText::_('COM_MINIORANGE_CANNOT_FIND_USER4').htmlspecialchars($search_base).JText::_('COM_MINIORANGE_CANNOT_FIND_USER5');
			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', $message, 'error');
		} 
		
		else if ($auth_response->statusMessage=="LDAP_NOT_RESPONDING") {

			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_LDAP_NOT_RESPONDING_CHECK_CONFIG'), 'error');
		} 
		
		else if ($auth_response->statusMessage=="USER_PASSWORD_DOESNTMATCH") {

			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_PASSWORD_MISMATCH'), 'error');
		} 
		
		else {

			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_LDAP_NOT_RESPONDING'), 'error');
		}
	}else{
		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration',JText::_('COM_MINIORANGE_MULTI_NO_PERMISSION_TO_SAVE'),'error');
	}
}

function moLdappsbsearchbases()
{
	$user=JFactory::getUser();

	//CHECKING THE USER PERMISSIONS
	if ($user->authorise('core.edit', 'com_miniorange_dirsync')){

		$result=MoLdapUtility::moLdapFetchData('#__miniorange_dirsync_config',array('id'=>'1'),'loadAssoc');
		$previous_search_bases=isset($result['search_base']) 	? MoLdapUtility::mo_ldap_decrypt($result['search_base']) 	 : "" ;
		$server_name=isset($result['ldap_server_url']) ? MoLdapUtility::mo_ldap_decrypt($result['ldap_server_url']) : "";

		if (empty($server_name)) {

			?><div style="color: white;	background-color: #e06d6d; padding:2%;margin-bottom:20px;text-align:center; border:1px solid #AEDB9A; font-size:18pt;"><?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL');?></div>
			
			<div style="margin-left:10px;padding:10px;border: 1px solid black;">
			<?php echo JText::_('COM_MINIORANGE_ERROR_RETRIEVING_SEARCH_BASE');?>
			</div><?php
			exit;
		}
		$data=MoLdapConfig::mo_ldap_psbsearchbases();
	 	?>
	 	<style>
			.inputGroup {background-color: #fff;display: block;margin: 10px 0;position: relative;}
			.inputGroup label {padding: 12px 30px;width: 100%;display: block;text-align: left;color: #3C454C;cursor: pointer;position: relative;z-index: 2;transition: color 200ms ease-in;overflow: hidden;}
			.inputGroup label:before {width: 100%;height: 100%;border-radius: 50%;content: '';background-color: #001b4c;position: absolute;left: 50%;top: 50%;transform: translate(-50%, -50%) scale3d(1, 1, 1);transition: all 300ms cubic-bezier(0.4, 0.0, 0.2, 1);opacity: 0;z-index: -1;}
			.inputGroup label:after {width: 32px;height: 32px;content: '';border: 2px solid #D1D7DC;background-color: #fff;background-image: url("data:image/svg+xml,%3Csvg width='32' height='32' viewBox='0 0 32 32' xmlns='http://www.w3.org/2000/svg'%3E%3Cpath d='M5.414 11L4 12.414l5.414 5.414L20.828 6.414 19.414 5l-10 10z' fill='%23fff' fill-rule='nonzero'/%3E%3C/svg%3E");background-repeat: no-repeat;background-position: 2px 3px;border-radius: 50%;z-index: 2;position: absolute;right: 30px;top: 50%;transform: translateY(-50%);cursor: pointer;transition: all 200ms ease-in;}
			.inputGroup input:checked ~ label {color: #fff;}
			.inputGroup input:checked ~ label:before {transform: translate(-50%, -50%) scale3d(56, 56, 1);opacity: 1;}
			.inputGroup input:checked ~ label:after {background-color: #54E0C7;border-color: #54E0C7;}
			.inputGroup input {width: 32px;height: 32px;order: 1;z-index: 2;position: absolute;right: 30px;top: 50%;transform: translateY(-50%);cursor: pointer;visibility: hidden;}
		</style>
	 	<?php
		if ($data) {
			echo '<script>
			jQuery(document).ready(function($) {
				$(".sidebar-wrapper").hide();
				$(".header").hide();
			});
			</script>';
			 echo '	<div style="color: #fff;background-color: #001b4c;padding:2%;margin-bottom:20px;text-align:center;font-size:18pt;">
						'.JText::_('COM_MINIORANGE_LIST_OF_SEARCH_BASES').'
					 </div>
					 <span><b style="color:var(--body-color);"> &nbsp; &nbsp;';
					 echo JText::_('COM_MINIORANGE_SELECT_SEARCH_BASE'); 
					 echo '</b></span></br></br>
					 
					 <div>';
						  ?>
						  <form name="sbase" method="post" action="<?php echo JRoute::_('index.php?option=com_miniorange_dirsync&view=accountsetup&task=accountsetup.moLdapUpdatesearchbase'); ?>" id="updatesearchbase_form" >
						  <?php
							 for ($i=0; $i <count($data); $i++) {
								 $check =0;
								 if (strcasecmp($data[$i], $previous_search_bases) == 0){
									 $check =1;
								 } 
								 if($check==0){
							 
									 echo "<div class='inputGroup'>
									 <input type='radio' name='select_ldap_search_bases' id='select_ldap_search_".$i."' style='overflow:hidden; -webkit-appearance: none;'value='$data[$i]' required><label for='select_ldap_search_".$i."'>" . $data[$i] . "</label></div>";
								 }
								 else{
									 echo "<div class='inputGroup'>
								 
									 <input type='radio' name='select_ldap_search_bases' id='select_ldap_search_".$i."' style='overflow:hidden; -webkit-appearance: none' checked value='$data[$i]' required><label for='select_ldap_search_".$i."'>" . $data[$i] ."</label></div>";
								 }
							 }
							 echo '
								 
							 <div style="margin:3%;display:block;text-align:center;">
								 <table style="border: none; width: 100%">
									 <tr style="border: none;">
										 <td style="border: none;"> 
											 <input type="button" id="submitbase" value="'.JText::_('COM_MINIORANGE_SUBMIT').'" name="submitbase" style="padding:1%;width:100px;background:#001b4c;cursor: pointer;font-size:15px;border-width: 1px;border-style: solid;border-radius: 3px;white-space: nowrap;box-sizing: border-box;color: #FFF;" onclick="mo_ldap_submit_search_base()"> 
											 <input type="button"  id ="searchbase" value="'.JText::_('COM_MINIORANGE_CLOSE').'" onclick="self.close();" style="padding:1%;width:100px;background: #001b4c;cursor: pointer;font-size:15px;border-width: 1px;border-style: solid;border-radius: 3px;white-space: nowrap;box-sizing: border-box;;color: #FFF;"/>
										 </td>
									 </tr>
								 </table>
							 </div>
						 </form></div>';

		 }
		}
}
	
function moLdapUpdatesearchbase()
{
	$user=JFactory::getUser();

	//CHECKING THE USER PERMISSIONS
	if ($user->authorise('core.edit', 'com_miniorange_dirsync')){

		$post=JFactory::getApplication()->input->post->getArray();

		$search_base_string=$post['select_ldap_search_bases'];
		$search_base_string=MoLdapUtility::mo_ldap_encrypt($search_base_string);

		$database_name='#__miniorange_dirsync_config';
		$updatefieldsarray=array(
			'search_base'=> $search_base_string,

		);

		MoLdapUtility::moLdapUpdateData($database_name, $updatefieldsarray,array('id'=>'1'));
		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', JText::_('COM_MINIORANGE_SAVED_SEARCH_BASE'));
	}else{
		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration',JText::_('COM_MINIORANGE_MULTI_NO_PERMISSION_TO_SAVE'),'error');
	}
}
	

	function moLdapContactUs()
	{
		$post=JFactory::getApplication()->input->post->getArray();
		$query_email=isset($post['mo_ldap_query_email'])? $post['mo_ldap_query_email'] : '';
		$query=isset($post['mo_ldap_query']) ? $post['mo_ldap_query'] : '';
		$query_type=isset($post['mo_ldap_setup_call_issue'])		? $post['mo_ldap_setup_call_issue']		: '';
		$query_withconfig=isset($post['mo_ldap_query_withconfig']) ? $post['mo_ldap_query_withconfig'] : '';
		$attributes=MoLdapUtility::moLdapFetchData('#__miniorange_dirsync_config',array('id'=>'1'),'loadAssoc');
		if ($query_withconfig !=1) {

			$attributes['search_filter']='';
			$attributes['username']='';
			$attributes['email']='';
		}

		if (sizeof(array_unique(str_split($query))) < 10) {
			$message=JText::_('COM_MINIORANGE_ENTER_PROPER_QUERY');
			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo', $message, 'error');
			return;
		}
	
		if (MoLdapUtility::mo_ldap_check_empty_or_null($query_email) || MoLdapUtility::mo_ldap_check_empty_or_null($query)) {
			$message=JText::_('COM_MINIORANGE_QUERY_WITH_EMAIL');
			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo', $message, 'error');
			return;
		} else {
			$query=$post['mo_ldap_query'];
			$email=$post['mo_ldap_query_email'];
			$phone=$post['mo_ldap_query_phone'];
			$contact_us=new MoLdapCustomer();
			$submited=json_decode($contact_us->mo_ldap_submit_contact_us($email, $phone, $query, $attributes, $query_type),true);
            if(json_last_error()==JSON_ERROR_NONE) {
                if(is_array($submited) && array_key_exists('status', $submited) && $submited['status']=='ERROR'){
                    $this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo', $submited['message'],'error');
                }else{
                    if ( $submited==false ) {
						$message=JText::_('COM_MINIORANGE_QUERY_NOT_SUBMITTED');
                        $this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo', $message,'error');
                    } else {
						$message=JText::_('COM_MINIORANGE_QUERY_SENT');
                        $this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo', $message);
                    }
                }
            }else{

				$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo', $submitted, 'error');
			}
		}
	}

	function moLdapExport(){

		$ldap_server_details=MoLdapUtility::moLdapFetchData('#__miniorange_dirsync_config',array('id'=>'1'),'loadAssoc');
		$ldap_server_url=$ldap_server_details['ldap_server_url'];
		$username=$ldap_server_details['username'];
		if($ldap_server_url=='' && $username=='')
		{
			$message=JText::_('COM_MINIORANGE_FILL_ATTRIBUTE_MAPPING_SERVER_URL');
			$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', $message, 'error');
			return;
		}

		foreach($ldap_server_details as $key=> $value)
		{
			if($key=='ldap_server_url' || $key=='service_account_dn' || $key=='service_account_password' || $key=='search_base')
			{
				$mo_ldap_decrypted_value=MoLdapUtility::mo_ldap_decrypt($value);
				$ldap_server_details[$key]=$mo_ldap_decrypted_value;
			}
		}

		$ldap_group_mapping=MoLdapUtility::moLdapFetchData('#__miniorange_ldap_role_mapping',array('id'=>'1'),'loadAssoc');
		$ntlm_configuration=MoLdapUtility::moLdapFetchData('#__miniorange_ntlm',array('id'=>'1'),'loadAssoc')	;
		$plugin_configuration=array();
		array_unshift($ldap_server_details, 'miniorange_dirsync_config');
		array_unshift($ldap_group_mapping, 'miniorange_ldap_role_mapping');
		array_unshift($ntlm_configuration, 'miniorange_ntlm');
		array_push($plugin_configuration, $ldap_server_details, $ldap_group_mapping, $ntlm_configuration);
		
		$filecontentd=json_encode($plugin_configuration, JSON_PRETTY_PRINT);
		
		header('Content-Disposition: attachment; filename=ldap-server.json'); 
		header('Content-Type: application/json'); 
		print_r($filecontentd);
	
		
		$message=JText::_('COM_MINIORANGE_EXPORT_SUCCESSFUL'); 
		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=ldapconfiguration', $message);
		exit;
	}	
	
    function mo_ldap_requestfordemo()
    {
        $post=JFactory::getApplication()->input->post->getArray();
		
        if ((!isset($post['email'])) || (!isset($post['plan'])) || (!isset($post['description']))) {
            $this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo');
            return;
        }
        $email=$post['email'];
        $plan=$post['plan'];
		$add_on=$post['add_on'];
        $description=trim($post['description']);
        $demo='Demo';
	
        if (!isset($plan) || empty($description)) {
            $this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo', JText::_('COM_MINIORANGE_FILL_PLAN_DETAILS_FOR_DEMO'), 'error');
            return;
        }

        $customer=new MoLdapCustomer();
        $response=json_decode($customer->mo_ldap_request_for_demo($email, $plan, $demo, $description, $add_on));

        if ($response->status !='ERROR'){
            $this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo', JText::_('COM_MINIORANGE_DEMO_REQUEST_RECIEVED_SUCCESSFULLY'));

		 } else {
            $this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo', JText::_('COM_MINIORANGE_CONTACT_US_AGAIN'), 'error');
            return;
        }

    }

	function callContactUs(){
		
	$post=JFactory::getApplication()->input->post->getArray();
	if (count($post)==0) {
		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo');
		return;
	}
	
	$query_email=isset($post['mo_ldap_setup_call_email']) 		? $post['mo_ldap_setup_call_email']		: '';
	$query=isset($post['mo_ldap_setup_call_issue'])		? $post['mo_ldap_setup_call_issue']		: '';
	$description=isset($post['mo_ldap_setup_call_desc'])		? $post['mo_ldap_setup_call_desc']		: '';
	$callDate=isset($post['mo_ldap_setup_call_date'])		? $post['mo_ldap_setup_call_date']		: '';
	$timeZone=isset($post['mo_ldap_setup_call_timezone'])	? $post['mo_ldap_setup_call_timezone']	: '';
	$query_withconfig=isset($post['mo_ldap_query_withconfig']) 		? $post['mo_ldap_query_withconfig'] 	: '';
	$attributes=MoLdapUtility::moLdapFetchData('#__miniorange_dirsync_config',array('id'=>'1'),'loadAssoc');
	if ($query_withconfig !=1) {

		$attributes['search_filter']='';
		$attributes['username']='';
		$attributes['email']='';
	}
	if (MoLdapUtility::mo_ldap_check_empty_or_null($timeZone) || MoLdapUtility::mo_ldap_check_empty_or_null($callDate) || MoLdapUtility::mo_ldap_check_empty_or_null($query_email) ||  MoLdapUtility::mo_ldap_check_empty_or_null($description)) {
		$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo', JText::_('COM_MINIORANGE_SUPPORT_FILL_ALL_FIELDS'), 'error');
		return;
	} else {
		$contact_us=new MoLdapCustomer();
		$submited=json_decode($contact_us->mo_ldap_request_for_setupCall($query_email, $query, $description, $callDate, $timeZone, $attributes), true);
		if (json_last_error()==JSON_ERROR_NONE) {
			if (is_array($submited) && array_key_exists('status', $submited) && $submited['status']=='ERROR') {
				$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo', $submited['message'], 'error');
			} else {
				if ($submited==false) {
					$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo', JText::_('COM_MINIORANGE_QUERY_NOT_SUBMITTED'), 'error');
				} else {
					$this->setRedirect('index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo', JText::_('COM_MINIORANGE_QUERY_SENT'));
				}
			}
		}

	}
	}	
}