<?php
/** 
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
* @package 		miniOrange LDAP
* @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/
/**
This library is miniOrange Authentication Service. 
Contains Request Calls to Customer service.

**/

defined( '_JEXEC' ) or die( 'Restricted access' );
require_once JPATH_ADMINISTRATOR.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_miniorange_dirsync'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'mo_ldap_utility.php';
class MoLdapCustomer{
	
	public $email;

	public $phone;
	public $customerKey;
	public $transactionId;

	/*
	** Initial values are hardcoded to support the miniOrange framework to generate OTP for email.
	** We need the default value for creating the OTP the first time,
	** As we don't have the Default keys available before registering the user to our server.
	** This default values are only required for sending an One Time Passcode at the user provided email address.
	*/
	
	//auth
	private $defaultCustomerKey="16555";
	private $defaultApiKey="fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";
	
	
	function mo_ldap_get_customer_key($email,$password) {
		if(!MoLdapUtility::mo_ldap_is_curl_installed()) {
			return json_encode(array("apiKey"=>'CURL_ERROR','token'=>'<a href="http://php.net/manual/en/curl.installation.php">PHP cURL extension</a> is not installed or disabled.'));
		}
		
		$hostname=MoLdapUtility::mo_ldap_get_hostname();
		$url=$hostname. "/moas/rest/customer/key";
		$fields=array(
			'email'=> $email,
			'password'=> $password
		);
		$field_string=json_encode($fields);
		$http_header_array=array( 'Content-Type: application/json', 'charset: UTF-8', 'Authorization: Basic' );
		return self::mo_post_curl($url,$field_string,$http_header_array);
	}
	
public static function mo_ldap_submit_feedback_form($email,$phone,$query)
	{
	
        $url='https://login.xecurify.com/moas/api/notify/send';       
        $customerKey="16555";
		$apiKey="fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";

        $currentTimeInMillis=round(microtime(true) * 1000);
        $stringToHash=$customerKey .  number_format($currentTimeInMillis, 0, '', '') . $apiKey;
        $hashValue=hash("sha512", $stringToHash);
        $customerKeyHeader="Customer-Key: " . $customerKey;
        $timestampHeader="Timestamp: " .  number_format($currentTimeInMillis, 0, '', '');
        $authorizationHeader="Authorization: " . $hashValue;
        $fromEmail=$email;
        $subject="MiniOrange Joomla Feedback for LDAP ";
        $currentUserEmail=JFactory::getUser();
        $adminEmail=$currentUserEmail->email;
         $query1=" MiniOrange joomla LDAP [Free]  ";
         $content='<div >Hello, <br><br>Company :<a href="'.$_SERVER['SERVER_NAME'].'" target="_blank" >'.$_SERVER['SERVER_NAME'].'</a><br><br>Phone Number :'.$phone.'<br><br><b>Email :<a href="mailto:'.$fromEmail.'" target="_blank">'.$fromEmail.'</a></b><br><br><strong>Admin Email : </strong><a href="mailto:'.$adminEmail.'" target="_blank">'.$adminEmail.'</a><br><br><b>Plugin Deactivated: '.$query1. '</b><br><br><b>Reason: ' .$query. '</b></div>';

        $fields=array(
            'customerKey'=> $customerKey,
            'sendEmail'=> true,
            'email'=> array(
                'customerKey'=> $customerKey,
                'fromEmail'=> $fromEmail,
                'bccEmail'=> 'jeswanth@xecurify.com',
                'fromName'=> 'miniOrange',
                'toEmail'=> 'joomlasupport@xecurify.com',
                'toName'=> 'joomlasupport@xecurify.com',
                'subject'=> $subject,
                'content'=> $content
            ),
        );
        
		$field_string=json_encode($fields);
		$http_header_array=array( 'Content-Type: application/json',$customerKeyHeader, $timestampHeader, $authorizationHeader);
		return self::mo_post_curl($url,$field_string,$http_header_array);
	}
	

	function mo_ldap_submit_contact_us( $q_email, $q_phone, $query, $attributes , $query_type) {
		
		if(!MoLdapUtility::mo_ldap_is_curl_installed()) {
            return json_encode(array("status"=>'ERROR','message'=>'<a href="http://php.net/manual/en/curl.installation.php">PHP CURL extension</a> is not installed or disabled.'));
		}
		$url='https://login.xecurify.com/moas/api/notify/send';
        $ch=curl_init($url);
        $customerKey="16555";
        $apiKey="fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";
	
        $currentTimeInMillis=round(microtime(true) * 1000);
        $stringToHash=$customerKey . number_format($currentTimeInMillis, 0, '', '') . $apiKey;
        $hashValue=hash("sha512", $stringToHash);
        $customerKeyHeader="Customer-Key: " . $customerKey;
        $timestampHeader="Timestamp: " . number_format($currentTimeInMillis, 0, '', '');
        $authorizationHeader="Authorization: " . $hashValue;
        $fromEmail=$q_email;
		$phpVersion=phpversion();
		$jVersion=new JVersion;
		$jCmsVersion=$jVersion->getShortVersion();
		$moPluginVersion=MoLdapUtility::mo_ldap_get_plugin_version();
		$moSystemOS=MoLdapUtility::mo_ldap_get_operating_system();
        $subject="Query for MiniOrange Joomla LDAP Free | " . $phpVersion ." | ". $jCmsVersion." | ".$moPluginVersion.' | ' . $moSystemOS.' - '.$fromEmail;
		$query=$query.'<br><strong>Configuration: </strong><br> <strong>Search filter:</strong>  '.$attributes['search_filter'].'<br> <strong>Username: </strong> '. $attributes['username'].' <br> <strong>Email: </strong>'.$attributes['email'];
	
		$currentUserEmail=JFactory::getUser();
        $adminEmail=$currentUserEmail->email;
        $pluginInfo='['.$moPluginVersion.' | PHP ' . $phpVersion.' | System OS '.$moSystemOS.' ] ';
		$query='[MiniOrange Joomla LDAP Free | '.$phpVersion. ' | '.$jCmsVersion.' | '.$moPluginVersion.' | ' . $moSystemOS.'] ' . $query;
        $content='<div >Hello, <br><br>
					<strong>Company</strong> :<a href="'.$_SERVER['SERVER_NAME'].'" target="_blank" >'.$_SERVER['SERVER_NAME'].'</a><br><br>
					<strong>Phone Number</strong> :'.$q_phone.'<br><br>
					<strong>Admin Email : </strong><a href="mailto:'.$adminEmail.'" target="_blank">'.$adminEmail.'</a><br><br>
					<b>Email :<a href="mailto:'.$fromEmail.'" target="_blank">'.$fromEmail.'</a></b><br><br>
					<b>Query Type: </b>'.$query_type.'<br><br>
                    <b>Query</b>: '.$query. '</b></div>';

        $fields=array(
            'customerKey'=> $customerKey,
            'sendEmail'=> true,
            'email'=> array(
                'customerKey'=> $customerKey,
                'fromEmail'=> $fromEmail,
                'fromName'=> 'miniOrange',
                'toEmail'=> 'joomlasupport@xecurify.com',
                'toName'=> 'joomlasupport@xecurify.com',
                'subject'=> $subject,
                'content'=> $content
            ),
        );
        $field_string=json_encode($fields);
		$http_header_array=array( 'Content-Type: application/json', $customerKeyHeader, $timestampHeader, $authorizationHeader);
		return self::mo_post_curl($url,$field_string,$http_header_array);
		
	}
	

	function mo_ldap_request_for_demo($email, $plan,$demo,$description='',$add_on="")
    {
        $url='https://login.xecurify.com/moas/api/notify/send';
        $ch=curl_init($url);
        $customerKey="16555";
        $apiKey="fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";

        $currentTimeInMillis=round(microtime(true) * 1000);
        $stringToHash=$customerKey . number_format($currentTimeInMillis, 0, '', '') . $apiKey;
        $hashValue=hash("sha512", $stringToHash);
        $customerKeyHeader="Customer-Key: " . $customerKey;
        $timestampHeader="Timestamp: " . number_format($currentTimeInMillis, 0, '', '');
        $authorizationHeader="Authorization: " . $hashValue;
        $fromEmail=$email;
        $subject='MiniOrange Joomla LDAP Request for '.$demo;

        $phpVersion=phpversion();
		$jVersion=new JVersion;
		$jCmsVersion=$jVersion->getShortVersion();
		$moPluginVersion=MoLdapUtility::mo_ldap_get_plugin_version();
		$moSystemOS=MoLdapUtility::mo_ldap_get_operating_system();

		$currentUserEmail=JFactory::getUser();
        $adminEmail=$currentUserEmail->email;
        $pluginInfo='['.$moPluginVersion.' | PHP ' . $phpVersion.' | System OS '.$moSystemOS.' ] ';

        $content='<div >Hello, <br>
                        <br><strong>Company :</strong><a href="' . $_SERVER['SERVER_NAME'] . '" target="_blank" >' . $_SERVER['SERVER_NAME'] . '</a><br><br>
						<strong>Admin Email :</strong><a href="mailto:'.$adminEmail.'"target="_blank">'.$adminEmail.'</a><br><br>
                        <strong>Email :</strong><a href="mailto:' . $fromEmail . '" target="_blank">' . $fromEmail . '</a><br><br>
                        <strong>Plugin Info: </strong>'.$pluginInfo.'<br><br>
                        <strong>'.$demo. ':</strong> ' . $plan . '<br><br>
						<strong>Add on :</strong>'.$add_on.'<br><br>
                        <strong>Description: </strong>' . $description . '</div>';

        $fields=array(
            'customerKey'=> $customerKey,
            'sendEmail'=> true,
            'email'=> array(
                'customerKey'=> $customerKey,
                'fromEmail'=> $fromEmail,
                'fromName'=> 'miniOrange',
                'toEmail'=> 'joomlasupport@xecurify.com',
                'toName'=> 'joomlasupport@xecurify.com',
                'subject'=> $subject,
                'content'=> $content
            ),
        );
        $field_string=json_encode($fields);
		$http_header_array=array( 'Content-Type: application/json', $customerKeyHeader, $timestampHeader, $authorizationHeader);
		return self::mo_post_curl($url,$field_string,$http_header_array);
    }

	public static function mo_post_curl($url, $fields, $http_header_array){
		$ch=curl_init($url);
		curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
		curl_setopt( $ch, CURLOPT_ENCODING, "" );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
		curl_setopt( $ch, CURLOPT_AUTOREFERER, true );
		curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );   
		
		curl_setopt( $ch, CURLOPT_MAXREDIRS, 10 );
		curl_setopt( $ch, CURLOPT_HTTPHEADER, $http_header_array );
		curl_setopt( $ch, CURLOPT_POST, true);
		curl_setopt( $ch, CURLOPT_POSTFIELDS, $fields);
		
		$proxy_server=MoLdapUtility::moLdapFetchData('#__miniorange_dirsync_config',array('id'=>'1'),'loadAssoc');
		$proxy_server_url=isset($proxy_server['proxy_server_url'])? $proxy_server['proxy_server_url'] : '';
		$proxy_server_port=isset($proxy_server['proxy_server_port']) ? $proxy_server['proxy_server_port']: '';
		$proxy_username=isset($proxy_server['proxy_username']) ? $proxy_server['proxy_username'] : '';
		$proxy_password=isset($proxy_server['proxy_password']) ? $proxy_server['proxy_password']: '';
		$proxy_check=isset($proxy_server['proxy_set']) ? $proxy_server['proxy_set']: '';
		if($proxy_check=="yes")
		{
			curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1); 
			curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
			curl_setopt($ch, CURLOPT_PROXY, $proxy_server_url);
			curl_setopt($ch, CURLOPT_PROXYPORT, $proxy_server_port);  
			curl_setopt($ch, CURLOPT_PROXYUSERPWD, $proxy_username.':'.$proxy_password);  
		}

		$content=curl_exec( $ch );
      
		 if(curl_errno($ch)){
            $error = array('status' => 'ERROR', 'message'=> curl_error($ch));
		   return json_encode($error);
		}
		curl_close($ch);

		return $content;
	}
	
	function mo_ldap_request_for_setupCall($email, $query, $description, $callDate, $timeZone, $attributes)
    {
        $url='https://login.xecurify.com/moas/api/notify/send';
        $customerKey="16555";
        $apiKey="fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";

        $currentTimeInMillis=round(microtime(true) * 1000);
        $stringToHash=$customerKey . number_format($currentTimeInMillis, 0, '', '') . $apiKey;
        $hashValue=hash("sha512", $stringToHash);
        $customerKeyHeader="Customer-Key: " . $customerKey;
        $timestampHeader="Timestamp: " . number_format($currentTimeInMillis, 0, '', '');
        $authorizationHeader="Authorization: " . $hashValue;
        $fromEmail=$email;

        $subject="MiniOrange Joomla LDAP Free - Screen Share/Call Request";
        $phpVersion=phpversion();
		
		$jVersion=new JVersion;
		$jCmsVersion=$jVersion->getShortVersion();
        $moPluginVersion=MoLdapUtility::mo_ldap_get_plugin_version();
		$moSystemOS=MoLdapUtility::mo_ldap_get_operating_system();

		$currentUserEmail=JFactory::getUser();
        $adminEmail=$currentUserEmail->email;

        $pluginInfo='[ LDAP FREE '.$moPluginVersion.' | PHP ' . $phpVersion.' | System OS '.$moSystemOS.' ] ';
		$query=$query.'<br><strong>Configuration: </strong><br> <strong>Search filter:</strong>  '.$attributes['search_filter'].'<br> <strong>Username: </strong> '. $attributes['username'].' <br> <strong>Email: </strong>'.$attributes['email'];
        $content='<div>Hello, <br><br>
                        <strong>Company :</strong><a href="' . $_SERVER['SERVER_NAME'] . '" target="_blank" >' . $_SERVER['SERVER_NAME'] . '</a><br><br>
                        <strong>Plugin Info: </strong>'.$pluginInfo.'<br><br>
						<strong>Admin Email :</strong><a href="mailto:'.$adminEmail.'"target="_blank">'.$adminEmail.'</a><br><br>
                        <strong>Email :</strong><a href="mailto:' . $fromEmail . '" target="_blank">' . $fromEmail . '</a><br><br>
                        <strong>Time Zone:</strong> ' . $timeZone . '<br><br><strong>Date to set up call: </strong>' . $callDate . '<br><br>
                        <strong>Issue : </strong>' . $query . '<br><br>
                        <strong>Description:</strong> ' . $description . '</div>';

        $fields=array(
            'customerKey'=> $customerKey,
            'sendEmail'=> true,
            'email'=> array(
                'customerKey'=> $customerKey,
                'fromEmail'=> $fromEmail,
                'fromName'=> 'miniOrange',
                'toEmail'=> 'joomlasupport@xecurify.com',
                'toName'=> 'joomlasupport@xecurify.com',
                'subject'=> $subject,
                'content'=> $content
            ),
        );
        $field_string=json_encode($fields);
		$http_header_array=array( 'Content-Type: application/json', $customerKeyHeader, $timestampHeader, $authorizationHeader);
		return self::mo_post_curl($url,$field_string,$http_header_array);
    }
}?>
