<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_miniorange_dirsync
 *
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
// No direct access to this file
defined('_JEXEC') or die('Restricted Access');
JHtml::_('script', JUri::base() . 'components/com_miniorange_dirsync/assets/js/jquery.1.11.0.min.js');
JHtml::_('script', JUri::base() . 'components/com_miniorange_dirsync/assets/js/bootstrap.min.js');
JHtml::_('stylesheet', JURI::base() .'components/com_miniorange_dirsync/assets/css/miniorange_boot.css');
JHtml::_('stylesheet', JURI::base() .'components/com_miniorange_dirsync/assets/css/miniorange_license.css');
JHtml::_('stylesheet', JURI::base() .'components/com_miniorange_dirsync/assets/css/bootstrap-tour-standalone.css');
JHtml::_('script', JURI::base() . 'components/com_miniorange_dirsync/assets/js/bootstrap-tour-standalone.min.js');
JHtml::_('stylesheet', 'https://maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css');
JHtml::_('script', JUri::base() . 'components/com_miniorange_dirsync/assets/js/visual_tour.js');
JHtml::_('script', JUri::base() . 'components/com_miniorange_dirsync/assets/js/utilityjs.js');
if(MoLdapUtility::mo_ldap_is_extension_installed('curl')==0){ ?>
    <p class="mo_ldap_highlight">( <?php echo JText::_('COM_MINIORANGE_WARNING');?>: <a href="http://php.net/manual/en/curl.installation.php" target="_blank"><?php echo JText::_('COM_MINIORANGE_CURL_EXTENSION');?></a> <?php echo JText::_('COM_MINIORANGE_CURL_EXTENSION_DISABLED');?></p>
    <?php
}
if(MoLdapUtility::mo_ldap_is_extension_installed('ldap')==0){?>
    <p class="mo_ldap_highlight">(<?php echo JText::_('COM_MINIORANGE_WARNING');?>: <a href="http://php.net/manual/en/ldap.installation.php" target="_blank"><?php echo JText::_('COM_MINIORANGE_LDAP_EXTENSION');?></a> <?php echo JText::_('COM_MINIORANGE_LDAP_EXTENSION_DISABLED');?></p>
    <?php	
}

$isSystemEnabled = JPluginHelper::isEnabled('system','miniorangedirsync');
if(!$isSystemEnabled)
{?>
	<div id="system-message-container">
			<div class="alert alert-error">
				<h4 class="alert-heading"><?php echo JText::_('COM_MINIORANGE_WARNING');?></h4>
					<div class="alert-message">		
					<?php echo JText::_('COM_MINIORANGE_ACTIVATE_SYSTEM_EXTENSION');?>	
					</div>
				</h4>
			</div>
		</div>
<?php } 	

$dirsync_active_tab = 'ldapconfiguration';
$get = JFactory::getApplication()->input->get->getArray();
if(isset($get['tab-panel']) && !empty($get['tab-panel'])){
	$dirsync_active_tab = $get['tab-panel'];
}

function getDirectoryDetails(){
	return(MoLdapUtility::moLdapFetchData('#__miniorange_dirsync_config',array('id'=>'1'),'loadAssoc'));
}

function getCustomerDetails() {
	return(MoLdapUtility::moLdapFetchData('#__miniorange_ldap_customer',array('id'=>'1'),'loadAssoc'));
}

?>

	<script src="//ajax.googleapis.com/ajax/libs/jquery/1.11.0/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.0/js/bootstrap.min.js"></script>
	<div class="mo_boot_row mo_support_floater">
        <div class="mo_boot_col-sm-12">
			<a style="float:right;margin-right:10px;font-weight:500;border-radius:18px;color:white" class="mo_boot_btn mo_boot_btn-danger mo_boot_px-4 mo_boot_py-1" target="_blank" onclick="window.open('https://plugins.miniorange.com/joomla-ldap-configuration')">Setup Guide</a>
			<a style="float:right; margin-right:10px;font-weight:500;border-radius:18px;background-color:white;border:1px solid black;text-decoration:none" class="mo_boot_btn mo_boot_px-4 mo_boot_py-1" href="index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo&query_type=trial"><i class="fa fa-envelope mo_boot_mx-1"></i>Free Trial</a>
        </div>
	</div>
	<div class="mo_boot_row">
	
		<a id="mo_ldap_ldapconfig_tab"  class="mo_boot_col mo_ldap_nav-tab <?php echo $dirsync_active_tab == 'ldapconfiguration' ? 'mo_nav_tab_active' : ''; ?>" href="#ldapconfiguration" style="border-left:0.01px solid var(--body-color)"
           onclick="mo_ldap_add_css_tab('#mo_ldap_ldapconfig_tab');" 
           data-toggle="tab"><?php echo JText::_('COM_MINIORANGE_TAB1_LDAP_CONFIGURATION'); ?>
        </a>	

		<a id="mo_ldap_signinsettings_tab"  class="mo_boot_col mo_ldap_nav-tab <?php echo $dirsync_active_tab == 'signinsettings' ? 'mo_nav_tab_active' : ''; ?>" href="#signinsettings"
           onclick="mo_ldap_add_css_tab('#mo_ldap_signinsettings_tab');" 
           data-toggle="tab"><?php echo JText::_('COM_MINIORANGE_TAB2_LDAP_SIGNIN'); ?>
        </a>
        <a id="mo_ldap_attribute_mapping_tab" class="mo_boot_col mo_ldap_nav-tab <?php echo $dirsync_active_tab == 'attributerolemapping' ? 'mo_nav_tab_active' : ''; ?>" href="#attributerolemapping"
           onclick="mo_ldap_add_css_tab('#mo_ldap_attribute_mapping_tab');"
           data-toggle="tab" ><?php echo JText::_('COM_MINIORANGE_TAB3_ATTRIBUTE_MAPPING_CONFIGURATION'); ?>
        </a>
		
        <a id="mo_ldap_group_mapping" class="mo_boot_col mo_ldap_nav-tab <?php echo $dirsync_active_tab == 'rolemapping' ? 'mo_nav_tab_active' : ''; ?>" href="#rolemapping"
           onclick="mo_ldap_add_css_tab('#mo_ldap_group_mapping');"
           data-toggle="tab"><?php echo JText::_('COM_MINIORANGE_TAB4_ROLE_MAPPING_CONFIGURATION'); ?>
        </a>

		<a id="mo_ldap_addons_tab" class="mo_boot_col mo_ldap_nav-tab <?php echo $dirsync_active_tab == 'addons' ? 'mo_nav_tab_active' : ''; ?>" href="#addons"
           onclick="mo_ldap_add_css_tab('#mo_ldap_addons_tab');"
           data-toggle="tab"><?php echo JText::_('COM_MINIORANGE_TAB5_LDAP_PROVISIONING'); ?>
        </a>

        <a id="mo_ldap_licensing_tab" class="mo_boot_col mo_license-tab mo_ldap_nav-tab <?php echo $dirsync_active_tab == 'licensing' ? 'mo_nav_tab_active' : ''; ?>" href="#licensing"
           onclick="mo_ldap_add_css_tab('#mo_ldap_licensing_tab');"
           data-toggle="tab"> <?php echo JText::_('COM_MINIORANGE_TAB6_LICENSE');?>
        </a>
		
	<!--Commenting out the Plugin Tour Tab -->
	<!-- <div class="mo_boot_mx-4 mo_boot_col-sm-1">
	<input type="button" id="mo_ldap_to_tourend" value="<?php //echo JText::_('COM_MINIORANGE_PLUGIN_TOUR'); ?>" onclick="mo_ldap_plugin_restart_tourot();" class="mo_float_left mo_boot_py-2 mo_boot_my-2" style="background-color:#bd362f; color:#fff; border-radius:3px; border-color:red;"/>
    </div> -->
	</div>


    <div class="tab-content">
		<div id="ldapconfiguration" class="tab-pane <?php echo $dirsync_active_tab == 'ldapconfiguration' ? 'active' : ''; ?>">
			<div class="mo_boot_row">
				<div class="mo_boot_col-sm-12">
					<?php moLdapConfiguration();?>
				</div>
			</div>
	    </div>
		
		<div id="signinsettings" class="tab-pane <?php echo $dirsync_active_tab == 'signinsettings' ? 'active' : ''; ?>">
           	<div class="mo_boot_row">
				<div class="mo_boot_col-sm-12" >
					<?php moLdapSigninSettings();?>
				</div>
			</div>
	    </div>
	    
		<div id="attributerolemapping" class="tab-pane <?php echo $dirsync_active_tab == 'attributerolemapping' ? 'active' : ''; ?>">
			<div class="mo_boot_row">
				<div class="mo_boot_col-sm-12" >
					<?php moLdapAttributeMapping();?>
				</div>
			</div>
	    </div>
	    
		<div id="rolemapping" class="tab-pane <?php echo $dirsync_active_tab == 'rolemapping' ? 'active' : ''; ?>">
			<div class="mo_boot_row">
				<div class="mo_boot_col-12">
					<?php moLdapRoleMapping();?>
				</div>
			</div>
        </div>	
        
		<div id="addons" class="tab-pane <?php echo $dirsync_active_tab == 'addons' ? 'active' : ''; ?>">
			<div class="mo_boot_row">
				<div class="mo_boot_col-sm-12">
					<?php moLdapShowAddon();?>
				</div>
			</div>
        </div>
		
		<div id="mo_ldap_trial_demo" class="tab-pane <?php echo $dirsync_active_tab == 'mo_ldap_trial_demo' ? 'active' : ''; ?>">
			<div class="mo_boot_row">
				<div class="mo_boot_col-sm-12" >
					<?php moLdapSupportTab();?>
				</div>
			</div>
        </div>

		<div id="licensing" class="tab-pane <?php echo $dirsync_active_tab == 'licensing' ? 'active' : ''; ?>">
			<div class="mo_boot_row">
				<div class="mo_boot_col-sm-12" >
					<?php moLdapLicensingPlan();?>
				</div>
			</div>
        </div>

    </div>
    <?php

function moStickySupport(){
	echo '
	<div class="mo_contact-us-container" style="z-index:1"> 
    	<div id="mo_contact_us" class="mo_boot_d-flex gap-mo-4 relative justify-end">
        	<input id="contact-us-toggle" type="checkbox" class="peer sr-only"/>

        	<a href="index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo&query_type=configuration" style="text-decoration:none" class="mo_contact_us_box">
            	<span class="mo-heading text-white leading-normal" style="font-size:14px;">Hello there! Need Help?<br>Drop us an Email</span>
        	</a>

        	<a href="index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo&query_type=configuration" class="mo_sticky_support" style="">
            	<svg width="60" height="60" viewBox="0 0 102 103" fill="none" class="cursor-pointer">
              		<g id="d4c51d1a6d24c668e01e2eb6a39325d7">
                		<rect width="102" height="103" rx="51" fill="url(#b69bc691e4b17a460c917ded85c3988c)"></rect>
                		<g id="0df790d6c3b93208dd73e487cf02eedc">
                 		<path id="e161bdf1e94ee39e424acc659f19e97c" fill-rule="evenodd" clip-rule="evenodd" d="M32 51.2336C32 37.5574 36.7619 33 51.0476 33C65.3333 33 70.0952 37.5574 70.0952 51.2336C70.0952 64.9078 65.3333 69.4672 51.0476 69.4672C36.7619 69.4672 32 64.9078 32 51.2336Z" stroke="white" stroke-width="4" stroke-linecap="round" stroke-linejoin="round"></path>
                  		<path id="c79e8f13aac8a6b146b9542a01c31ddc" d="M69.0957 44.2959C69.0957 44.2959 56.6508 55.7959 51.5957 55.7959C46.5406 55.7959 34.0957 44.2959 34.0957 44.2959" stroke="white" stroke-width="4" stroke-linecap="round" stroke-linejoin="round"></path>
                		</g>
              		</g>
              		<defs>
                		<linearGradient id="b69bc691e4b17a460c917ded85c3988c" x1="0" y1="0" x2="102" y2="103" gradientUnits="userSpaceOnUse">
                  			<stop stop-color="#2563eb"></stop>
                  			<stop offset="1" stop-color="#1d4ed8"></stop>
                		</linearGradient>
              		</defs>
           		 </svg>
        	</a>
		</div>
		
	</div>';
}

function moLdapConfiguration() 
{
	$moLdapServerConfig = new MoLdapConstants;
	$ldap_type = "";
	$ldap_port = "";
	$ldapServerUrl = "";
	$searchBase = "";
	$serviceAccountDn = "";
	$serviceAccountPassword = "";	
	$serverType = $moLdapServerConfig->getServerType();
	$ignoreLdaps = "";
	$enableTls = "";
	$searchFilter = "";
	$testUsername = "";
	$ActiveDirectoryAttributes = $moLdapServerConfig->getActiveDirectoryAttributes();
	if(!empty($moLdapServerConfig->getServerURL()))
	{
		$ldapServerUrl          = $moLdapServerConfig->getServerURL();
		$serviceAccountDn       = $moLdapServerConfig->getBindDN();
		$serviceAccountPassword = $moLdapServerConfig->getBindDNPassword();
		$searchBase 	  = $moLdapServerConfig->getSearchBase();
		$searchFilter 			  = $moLdapServerConfig->getSearchFilter();
		$serverType 			  = $moLdapServerConfig->getServerType();
		$ignoreLdaps             = $moLdapServerConfig->getIgnoreCertificateState();
		$enableTls 				= $moLdapServerConfig->getEnableTls();
		$testUsername 			= $moLdapServerConfig->getTestUsername();

		$ldap_type = strtok($ldapServerUrl, '://');
		$ldap_port = substr($ldapServerUrl, strrpos($ldapServerUrl, ':' )+1);
		$ldapServerUrlSub = substr($ldapServerUrl, strrpos($ldapServerUrl, '://' )+3);
		$ldapServerUrl =strtok($ldapServerUrlSub, ':');
		
    }
	
	if(empty($ldap_port))
	{
		$ldap_port = "389";	
	}
	moStickySupport();
    ?>
    
	<div id="mo_ldap_server_config" class="mo_boot_row mo_ldap_tab_theme">
		<div id="mo_ldap_server_config" class="mo_boot_col-sm-12">
			<div class="mo_boot_row" id="mo_ldap_server_configuration">
			<div class="mo_boot_col-sm-12 mo_boot_row mo_boot_py-4 mo_boot_mx-4">
				<h3 class="mo_ldap_heading mo_boot_col-sm-5"><?php echo JText::_('COM_MINIORANGE_LDAP_CONFIGURATION');?></h3>
				<form id="mo_ldap_export_form" class="mo_boot_col-sm-6" name="mo_ldap_export_form" method="post" action="<?php echo JRoute::_('index.php?option=com_miniorange_dirsync&view=accountsetup&task=accountsetup.moLdapExport'); ?>">
					<!-- <input type="button" id="mo_ldap_ot_tourconfig" class="mo_boot_btn mo_ldap_blue_buttons" value="<?php echo JText::_('COM_MINIORANGE_START_TOUR');?>" onclick="mo_ldap_restart_tourcon();"/> -->
					<!-- <input type="submit" class="mo_boot_btn mo_ldap_blue_buttons" id="mo_ldap_export_configuration" value="<?php echo JText::_('COM_MINIORANGE_EXPORT_SERVER_CONFIGURATION');?>" <?php if(!$ldapServerUrl) { echo 'disabled';} ?>> -->
				</form>
			</div>		
  
			<div class="mo_boot_col-sm-10 mo_boot_offset-1">
				<details id="mo_ldap_configuration_step1" class="mo_ldap_details_tag"  <?php if($ldapServerUrl) echo '';else echo 'open'?>>
                	<summary class="mo_ldap_summary_tag">Step 1 : <?php echo JText::_('COM_MINIORANGE_LDAP_CONNECTION');?></summary>
					<form id="mo_ldap_config_form" name="mo_ldap_config_form" method="post" action="<?php echo JRoute::_('index.php?option=com_miniorange_dirsync&view=accountsetup&task=accountsetup.moLdapSaveConfig'); ?>">
						<input type="hidden" id="ldap_configuration_action" name="ldap_configuration_action" value="saveconfig">
						<div class="mo_boot_row mo_boot_mt-4 mo_boot_my-2 mo_boot_offset-1">
							<div class="mo_boot_col-sm-3"><?php echo JText::_('COM_MINIORANGE_DIRECTORY_SERVER');?>:<span class="mo_ldap_highlight">*</span></div>
							<div id="mo_ldap_directory_servers" class="mo_boot_col-sm-8 mo_boot_my-1" >
                    			<select  name="mo_ldap_directory_server_type" id="mo_ldap_directory_server_type" class="form-select" style="width:50%;" required>
                        			<option value=""><?php echo JText::_('COM_MINIORANGE_SELECT_AD');?></option>
                        			<option value="msad" <?php if(isset($serverType) && $serverType == 'msad') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_MICROSOFT_AD');?></option>
                        			<option value="openldap" <?php if( isset($serverType) && $serverType == 'openldap') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_OPENLDAP');?></option>
                        			<option value="freeipa" <?php if( isset($serverType) && $serverType == 'freeipa') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_FREEIPA');?></option>
                        			<option value="jumpcloud" <?php if( isset($serverType) && $serverType == 'jumpcloud') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_JUMPCLOUD');?></option>
                        			<option value="other" <?php if( isset($serverType) && $serverType == 'other') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_OTHER');?></option>
                   	 			</select>
							</div>
						</div>

						<div class="mo_boot_row mo_boot_mt-2 mo_boot_offset-1">
							<div class="mo_boot_col-sm-3" id="ldapserverurl">
								<?php echo JText::_('COM_MINIORANGE_LDAP_SERVER_URL');?>:<span class="mo_ldap_highlight">*</span>
							</div>
							<div class="mo_boot_col-sm-2">
								<select class="form-select" id="mo_ldap_type" name="mo_ldap_type"  type="text">
									<option value="ldap" <?php if($ldap_type == 'ldap')echo 'selected'; ?>><?php echo JText::_('COM_MINIORANGE_LDAP');?></option>
									<option value="ldaps" <?php if($ldap_type == 'ldaps')echo 'selected'; ?> ><?php echo JText::_('COM_MINIORANGE_LDAPS');?></option>
								</select>
							</div>
				
							<div class="mo_boot_col-sm-4">
								<input class="form-control"  id="mo_ldap_server_url" name="mo_ldap_server_url" type="text" placeholder ="<?php echo JText::_('COM_MINIORANGE_LDAP_SERVER_URL_PLACEHOLDER');?>" value='<?php echo  $ldapServerUrl;?>' required>
							</div>
				
							<div class="mo_boot_col-sm-2">
								<input class="form-control" id="mo_ldap_port" name="mo_ldap_port" type="text" placeholder ="<?php echo JText::_('COM_MINIORANGE_PORT_NO_PLACEHOLDER');?>" value='<?php echo  $ldap_port;?>'>
							</div>
							<div class="mo_boot_col-sm-8 mo_boot_offset-3">
								<description style="font-size:14px"><?php echo JText::_('COM_MINIORANGE_LDAP_SERVER_URL_MESSAGE');?></description>
							</div>
						</div>
						
						<div class="mo_boot_row mo_boot_mt-2 mo_boot_offset-1">
							<div class="mo_boot_col-sm-3 mo_boot_my-2 mo_boot_offset-3">
								<?php echo JText::_('COM_MINIORANGE_IGNORE_LDAPS');?>: 
							</div>
							<div class="mo_boot_col-sm-1">
								<label class="mo_ldap_dir_search_switch mo_boot_my-2" id="">
									<input type="checkbox" name="mo_ignore_ldaps" <?php if($ignoreLdaps=='on') echo "checked"; ?>>
									<span id="" class="mo_ldap_dir_search_slider round"></span>
								</label>
							</div>
						</div>	
						<div class="mo_boot_row mo_boot_mt-2 mo_boot_offset-1">
							<div class="mo_boot_col-sm-3 mo_boot_my-2 mo_boot_offset-3">
								<?php echo JText::_('COM_MINIORANGE_CONNECTION_VIA_TLS');?>:
							</div>
							<div class="mo_boot_col-sm-1">
								<label class="mo_ldap_dir_search_switch mo_boot_my-2" id="">
									<input type="checkbox" name="mo_enable_tls" <?php if($enableTls=='on') echo "checked"; ?>>
									<span id="" class="mo_ldap_dir_search_slider round"></span>
								</label>
							</div>
						</div>	

						<div class="mo_boot_row">
							<div class="mo_boot_col-sm-9 mo_boot_offset-sm-3">
								<input hidden type="button" class="mo_boot_col_sm-4 mo_boot_btn mo_ldap_blue_buttons" value="<?php echo JText::_('COM_MINIORANGE_CONTACT_LDAP_SERVER');?>" onclick="mo_ldap_ping_ldap_server();"/>
							</div>
						</div>

						<div class="mo_boot_row mo_boot_mt-3 mo_boot_offset-1">
							<div class="mo_boot_col-sm-3" id="mo_ldap_server_account_dn">
								<?php echo JText::_('COM_MINIORANGE_SERVICE_ACCOUNT_DN');?>:<span class="mo_ldap_highlight">*</span>
							</div>
					
							<div class="mo_boot_col-sm-8">
								<input class="form-control" id="service_account_dn" name="service_account_dn" placeholder="<?php echo JText::_('COM_MINIORANGE_SERVICE_ACCOUNT_DN_PLACEHOLDER');?>" type="text"  value='<?php echo $serviceAccountDn;?>' required>
								<description style="font-size:14px"><?php echo JText::_('COM_MINIORANGE_SERVICE_ACCOUNT_DETAILS');?></description>
							</div>
						</div>

						<div class="mo_boot_row mo_boot_mt-2 mo_boot_offset-1">
							<div class="mo_boot_col-sm-3" id="mo_ldap_server_account_dnpwd">
								<?php echo JText::_('COM_MINIORANGE_SERVICE_ACCOUNT_PASSWORD');?>:<span class="mo_ldap_highlight">*</span>
							</div>

							<div class="mo_boot_col-sm-8">
								<input class="form-control" id="service_account_password" name="service_account_password" placeholder="<?php echo JText::_('COM_MINIORANGE_SERVICE_ACCOUNT_PASSWORD_PLACEHOLDER');?>" type="password"  value='<?php echo $serviceAccountPassword;?>' required>
								
							</div>
						</div>
						<div class="mo_boot_row mo_boot_my-3 mo_boot_text-center">
							<div class="mo_boot_col-sm-12">
								<input type="submit" value="<?php echo JText::_('COM_MINIORANGE_TEST_CONNECTION_AND_SAVE');?>" class="mo_boot_btn mo_ldap_blue_buttons">
								<input type="button" class='collapsed mo_boot_btn mo_boot_btn-danger'  value="<?php echo JText::_('COM_MINIORANGE_TROUBLESHOOTING');?>" data-toggle='collapse'  href='#mo_ldap_troubleshooting_ldap_server_connection' onclick="mo_ldap_troubleshooting_ldap_config()" >
								<br>
							</div>
						</div>
						<div id='mo_ldap_troubleshooting_ldap_server_connection' class="mo_boot_offset-1" style="display:none">
							<?php echo JText::_('COM_MINIORANGE_LDAP_SERVER_TROUBLESHOOTING');?>
						</div>		
					</form>
				</details>
			</div>	
		</div>
	</div>
	<div class="mo_boot_col-sm-10 mo_boot_offset-1" id="mo_ldap_attribute_mapping" >		
			
		<details id="mo_ldap_configuration_step2" class="mo_ldap_details_tag" <?php if(!empty($searchBase) && !empty($searchFilter)) echo '';else if(!$ldapServerUrl)echo ''; else echo 'open'?> >
            <summary class="mo_ldap_summary_tag">Step 2 : <?php echo JText::_('COM_MINIORANGE_LDAP_MAPPING_CONFIGURATION');?></summary>
            
			<form id="ldap_mapping_config_form" name="ldap_mapping_config_form" method="post" action="<?php echo JRoute::_('index.php?option=com_miniorange_dirsync&view=accountsetup&task=accountsetup.moLdapSaveUserMappingConfig'); ?>">
				<div class="mo_boot_row mo_boot_offset-1 mo_boot_my-2">
					<div class="mo_boot_col-sm-3" id="ldapsearchbase">
						<?php echo JText::_('COM_MINIORANGE_SEARCH_BASE');?>:<span class="mo_ldap_highlight">*</span>
					</div>	
					<div class="mo_boot_col-sm-5">
						<input class="form-control" id="search_base" name="search_base" placeholder="<?php echo JText::_('COM_MINIORANGE_SEARCH_BASE_PLACEHOLDER');?>" type="text" value='<?php echo $searchBase;?>'>
					</div>
					<div class="mo_boot_col-sm-3 mo_boot_my-1 mo_ldap_cursor-type">
						<div id="searchbases" class="mo_ldap_possible_search_bases" onclick="mo_ldap_possible_search_bases()">
							<svg style="margin-left: 10px" fill="#0076E1" height="15px" width="15px" version="1.1" id="Capa_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" viewBox="0 0 490.4 490.4" xml:space="preserve" stroke="#0076E1"><g id="SVGRepo_bgCarrier" stroke-width="0"></g><g id="SVGRepo_tracerCarrier" stroke-linecap="round" stroke-linejoin="round"></g><g id="SVGRepo_iconCarrier"> <g> 
							<path d="M484.1,454.796l-110.5-110.6c29.8-36.3,47.6-82.8,47.6-133.4c0-116.3-94.3-210.6-210.6-210.6S0,94.496,0,210.796 s94.3,210.6,210.6,210.6c50.8,0,97.4-18,133.8-48l110.5,110.5c12.9,11.8,25,4.2,29.2,0C492.5,475.596,492.5,463.096,484.1,454.796z M41.1,210.796c0-93.6,75.9-169.5,169.5-169.5s169.6,75.9,169.6,169.5s-75.9,169.5-169.5,169.5S41.1,304.396,41.1,210.796z"></path> </g> </g></svg> 
							<span style="font-size:14px">Select Search Base</span>   		
						</div>
					</div>

					<div class="mo_boot_offset-3"><em class='mo_boot_my-4 mo_boot_mx-4 mo_ldap_description'><?php echo JText::_('COM_MINIORANGE_MULTIPLE_SEARCH_BASE_DETAILS1');?> <a href="#" class="mo_ldap_premium" style='font-weight:600' onclick="mo_ldap_upgrade();">premium</a>
						<?php echo JText::_('COM_MINIORANGE_MULTIPLE_SEARCH_BASE_DETAILS2');?></em>
					</div>
				</div>
			
				<div class="mo_boot_row mo_boot_mt-2 mo_boot_my-4 mo_boot_offset-1">
					<div class="mo_boot_col-sm-3" id="mo_ldap_username_attribute">
						<?php echo JText::_('COM_MINIORANGE_USERNAME_ATTRIBUTE');?>:<span class="mo_ldap_highlight">*</span>
					</div>
					<div class="mo_boot_col-sm-5">
						<select class="form-select" id="search_filter" name="search_filter"  type="text" required>
							<option value="" disabled><?php echo JText::_('COM_MINIORANGE_SELECT_USERNAME_ATTRIBUTE');?></option>
							<option value="sAMAccountName" <?php if($searchFilter == 'sAMAccountName')echo 'selected'; ?> ><?php echo JText::_('COM_MINIORANGE_SAMACCOUNTNAME');?></option>
							<option value="userPrincipalName" <?php if($searchFilter == 'userPrincipalName')echo 'selected'; ?> ><?php echo JText::_('COM_MINIORANGE_USERPRINCIPALNAME');?></option>
							<option value="mail" <?php if($searchFilter == 'mail')echo 'selected'; ?> ><?php echo JText::_('COM_MINIORANGE_MAIL');?></option>
							<option value="cn" <?php if($searchFilter == 'cn') echo 'selected'; ?> ><?php echo JText::_('COM_MINIORANGE_CN');?></option>
							<option value="gidnumber" <?php if($searchFilter == 'gidnumber') echo 'selected'; ?> ><?php echo JText::_('COM_MINIORANGE_GIDNUMBER');?></option>
							<option value="uidNumber" <?php if($searchFilter == 'uidNumber') echo 'selected'; ?> ><?php echo JText::_('COM_MINIORANGE_UIDNUMBER');?></option>
							<option value="uid" <?php if($searchFilter == 'uid') echo 'selected'; ?> ><?php echo JText::_('COM_MINIORANGE_UID');?></option>
						</select>
					</div>

					<div class="mo_boot_col-sm-5 mo_boot_offset-3"><span class="mo_ldap_description" ><?php echo JText::_('COM_MINIORANGE_SEARCH_FILTER_DETAILS');?></span></div>
					<!-- <p class="mo_boot_col-sm-3 mo_boot_my-2"><?php echo JText::_('COM_MINIORANGE_CUSTOM_USERNAME_ATTRIBUTE');?><a href="<?php echo JRoute::_('index.php?option=com_miniorange_ldap_dir_search&view=accountsetup&tab-panel=mo_ldap_dir_search_license_plan')?>" style="text-decoration:none;font-size:12px;font-weight:bold">[PREMIUM]</a></p>
					<div class="mo_boot_col-sm-1">
						<label class="mo_ldap_dir_search_switch mo_boot_my-4" id="mo_ldap_dir_search_switch">
							<input type="checkbox" name="dir_search_custom_search_filter_checkbox" id="search_filter_check" disabled>
							<span id="mo_ldap_dir_search_slider" class="mo_ldap_dir_search_slider round"></span>
						</label>
					</div> -->
				</div>

				<div class="mo_boot_row mo_boot_mt-2">
					<div class="mo_boot_col-sm-12 mo_boot_my-2 mo_boot_text-center">
						<input type="submit" value="<?php echo JText::_('COM_MINIORANGE_SAVE_USER_MAPPING');?>" class="mo_boot_btn mo_ldap_blue_buttons">
						<input type="button" class="collapsed mo_boot_btn mo_boot_btn-danger" data-toggle='collapse' value="<?php echo JText::_('COM_MINIORANGE_TROUBLESHOOTING');?>"  href='#mo_ldap_troubleshooting_search_filter' onclick="mo_ldap_troubleshooting_search_filter()" >
						<br><br>
					</div>
				</div>
				<div id='mo_ldap_troubleshooting_search_filter' style="display:none">
					<?php echo JText::_('COM_MINIORANGE_SEARCH_FILTER_TROUBLESHOOTING');?>		
				</div>		
	   	 	</form>
		</details>	
	</div>

	<div class="mo_boot_col-sm-10 mo_boot_offset-1" id="mo_ldap_test_authentication">	
		<details id="mo_ldap_configuration_step3" class="mo_ldap_details_tag"  <?php if(!$searchFilter) echo '';else if(!$ldapServerUrl)echo ''; else echo 'open'?>>
            <summary class="mo_ldap_summary_tag">Step 3 : <?php echo JText::_('COM_MINIORANGE_LDAP_TEST_AUTHENTICATION');?></summary>
			<form id="mo_ldap_mapping_testauth_form" name="mo_ldap_mapping_testauth_form" method="post" action="<?php echo JRoute::_('index.php?option=com_miniorange_dirsync&view=accountsetup&task=accountsetup.testConfigurations'); ?>">
						
				<div class="mo_boot_row mo_boot_mt-2" id="mo_ldap_test_configuration">
					<div class="mo_boot_col-sm-10 mo_boot_offset-1">
						<div class="mo_boot_row mo_boot_my-2">
							<div class="mo_boot_col-sm-3">
								<?php echo JText::_('COM_MINIORANGE_TEST_USERNAME');?>:<span class="mo_ldap_highlight">*</span>
							</div>

							<div class="mo_boot_col-sm-5">
								<input class="form-control" id="test_username" name="test_username"  type="text" placeholder="<?php echo JText::_('COM_MINIORANGE_TEST_AUTHENTICATION_USERNAME');?>"  value="<?php echo $testUsername;?>" required>
							</div>
						</div>
						<div class="mo_boot_row mo_boot_mt-2">
							<div class="mo_boot_col-sm-3">
								<?php echo JText::_('COM_MINIORANGE_TEST_PASSWORD');?>:<span class="mo_ldap_highlight">*</span>
							</div>
							<div class="mo_boot_col-sm-5">
								<input class="form-control" id="test_password" name="test_password"  type="password" placeholder = "<?php echo JText::_('COM_MINIORANGE_TEST_AUTHENTICATION_PASSWORD');?>" required>
							</div>
						</div>

						<div class="mo_boot_row mo_boot_my-2 mo_boot_text-center">
							<div class="mo_boot_col-sm-12 mo_boot_my-2">
								<input type="submit" value="<?php echo JText::_('COM_MINIORANGE_TEST_CONFIGURATION');?>" class="mo_boot_btn mo_ldap_blue_buttons">
								<input type="button" class="collapsed mo_boot_btn mo_boot_btn-danger"  value="<?php echo JText::_('COM_MINIORANGE_TROUBLESHOOTING');?>"  href='#mo_ldap_troubleshooting_test_configuration'  onclick="mo_ldap_troubleshooting_test_config()" >
							</div>
						</div>
					</div>
					<div id='mo_ldap_troubleshooting_test_configuration' style="display:none">
						<?php echo JText::_('COM_MINIORANGE_TEST_CONFIGURATION_TROUBLESHOOTING');?>
					</div>	
				</div>
	    	</form>
		</details>		
	</div>
	</div>

<script>
    
	jQuery(document).change(function(){

		var ldapType = document.getElementById("mo_ldap_type").value;
		if(ldapType == 'ldaps')
			document.getElementById('mo_ldap_port').value = '636';

	});

	function mo_ldap_possible_search_bases(){

		var ldapServerUrl = document.getElementById("mo_ldap_server_url").value;
		if (!ldapServerUrl || ldapServerUrl.trim() == "") {
			alert("Enter LDAP Server URL");
		}

		else{
			var url = '<?php echo JURI::root(); ?>';
			testconfigurl = url+'administrator/index.php?option=com_miniorange_dirsync&view=accountsetup&task=accountsetup.moLdappsbsearchbases';
			var myWindow = window.open(testconfigurl, 'POSSIBLE SEARCH BASES / BASE DNs ', 'scrollbars=1 width=800, height=800');
		}
	}

    
</script>
    
<?php
}	

function moLdapSigninSettings()
{		
	$moLdapServerConfig = new MoLdapConstants;
    $enableLdap =	$moLdapServerConfig->getEnableLdap();	
	$searchFilter = $moLdapServerConfig->getSearchFilter(); 	
	moStickySupport();	
	?>
	<div class="mo_boot_row mo_ldap_tab_theme">
		<div class="mo_boot_col-sm-12 mo_boot_my-4">
			<h3 class="mo_boot_col-sm-8 mo_ldap_heading"><?php echo JText::_('COM_MINIORANGE_ENABLE_LOGIN');?></h3>
		</div>

		<form class="mo_boot_mx-4" name="mo_ldap_signin_form" id="mo_ldap_enable_both_login_form" method="post" action="<?php echo JRoute::_('index.php?option=com_miniorange_dirsync&view=accountsetup&task=accountsetup.moLdapSavelogin'); ?>">
			
			<div class="mo_boot_col-sm-12 mo_boot_mt-4">
				<input type="checkbox" <?php if(!$searchFilter){ echo 'disabled';} ?> name ="mo_ldap_login" value="ch" <?php if($enableLdap=='ch') echo "checked"; ?> >
				<?php echo JText::_('COM_MINIORANGE_ENABLE_LOGIN_DETAILS1');?>
			</div>
			<div class="mo_boot_row mo_boot_mt-2">
				<div class="mo_boot_col-sm-4 mo_boot_mx-4 mo_boot_my-2">
					<p><strong><?php echo JText::_('COM_MINIORANGE_REDIRECT_URL');?> </strong><a href="#" class="mo_ldap_premium" style="font-size:0.8rem" onclick="mo_ldap_upgrade();"><strong>[BASIC, <?php echo JText::_('COM_MINIORANGE_PREMIUM');?>]</strong></a><p>
				</div>
				<div class="mo_boot_col-sm-6">
					<input type="text" id = "mo_ldap_redirect_url" name="mo_ldap_redirect_url" class="form-control" placeholder ="<?php echo JText::_('COM_MINIORANGE_REDIRECT_URL_PLACEHOLDER');?>" disabled>		
				</div>
				<div class="mo_boot_col-sm-12 mo_boot_mx-4">
					<p><?php echo JText::_('COM_MINIORANGE_REDIRECT_URL_DESCRIPTION');?></p>
				</div>
			</div>
			<div class="mo_boot_row mo_boot_py-4">
			<div class="mo_boot_col-sm-11 mo_boot_mx-4">
				<input type="submit" <?php if(!$searchFilter){ echo 'disabled';} ?> value="<?php echo JText::_('COM_MINIORANGE_SAVE_SIGN_IN_SETTINGS');?>" class="mo_boot_btn mo_ldap_blue_buttons">
			</div></div>
        </form>
	</div>
	<?php	
}

function moLdapAttributeMapping(){	

	$moLdapServerConfig = new MoLdapConstants;
	$username = $moLdapServerConfig->getUsernameAttribute();
	$email = $moLdapServerConfig->getEmailAttribute();
	$name = $moLdapServerConfig->getNameAttribute();
	$searchFilter = $moLdapServerConfig->getSearchFilter();
	$ProfileAttributesList = array("address1","address2","city","region","country","postal_code","phone","website","favoritebook","aboutme");
	$ActiveDirectoryAttributes = $moLdapServerConfig->getActiveDirectoryAttributes();
	$ActiveDirectoryUserAttributes = $moLdapServerConfig->getTestConfigDetails();
	$UserName = $moLdapServerConfig->getTestConfigUsername();
	moStickySupport();
	?>

	<div class="mo_boot_row mo_ldap_tab_theme">
		
		<div class="mo_boot_col-sm-8 mo_boot_row">
			
			<div class="mo_boot_col-sm-8 mo_boot_my-4">
				<!-- <input type="button" id="mo_ldap_ot_tourattr" value="<?php echo JText::_('COM_MINIORANGE_START_TOUR');?>" onclick="mo_ldap_restart_tourattr();" class="mo_boot_btn mo_boot_btn mo_ldap_blue_buttons"/>		 -->
				<h3 class="mo_ldap_heading mo_boot_mx-4"><?php echo JText::_('COM_MINIORANGE_ATTRIBUTE_MAPPING');?></h3>	
			</div>

			<div class="mo_boot_col-sm-12 mo_boot_my-2">
				<div class="mo_boot_row">
					<div class="mo_boot_col-sm-10 mo_boot_offset-1">
						<?php echo JText::_('COM_MINIORANGE_TEST_ATTRIBUTE_MAPPING');?>
					</div>
				</div>
				<div class="mo_boot_row mo_boot_mt-2">
					<div class="mo_boot_col-sm-3 mo_boot_offset-1">
						<strong><?php echo JText::_('COM_MINIORANGE_USERNAME');?>:<strong class="mo_ldap_highlight">*</strong></strong>
					</div>
					<div class="mo_boot_col-sm-7">
						<input class="form-control" id="test_username_attr" name="test_username_attr"  type="text" placeholder="<?php echo JText::_('COM_MINIORANGE_CHECK_ATTRIBUTES_RECEIVING_PLACEHOLDER');?>"  >
					</div>
				</div>
				<div class="mo_boot_row mo_boot_my-2">
					<div class="mo_boot_col-sm-11 mo_boot_offset-1 mo_boot_my-2">
						<input type="button" <?php if(!$searchFilter){ echo 'disabled';} ?> value="<?php echo JText::_('COM_MINIORANGE_CHECK_ATTRIBUTES_RECEIVING');?>" onclick="mo_ldap_test_configuration()"; class="mo_boot_btn mo_ldap_blue_buttons">
					</div>
				</div>
			</div>
			<div class="mo_boot_col-sm-12 mo_boot_mt-2">
				<form name="mo_ldap_attribute_mapping_form" method="post" action="<?php echo JRoute::_('index.php?option=com_miniorange_dirsync&view=accountsetup&task=accountsetup.moLdapAttributeMapping'); ?>">
               		<div class="mo_boot_row">
						<div class="mo_boot_col-sm-10 mo_boot_offset-1">
							<h3 class="mo_ldap_sub_heading"><?php echo JText::_('COM_MINIORANGE_BASIC_ATTRIBUTE_MAPPING');?></h3>	
							<p class="alert alert-secondary mo_boot_my-2"><?php echo JText::_('COM_MINIORANGE_BASIC_ATTRIBUTES_NOTE');?></p>
						</div>
			   		</div>
			   		<div class="mo_boot_row mo_boot_mt-2 mo_boot_my-2">
						<div class="mo_boot_col-sm-3 mo_boot_my-2 mo_boot_offset-1">
							<strong><?php echo JText::_('COM_MINIORANGE_JOOMLA_ATTRIBUTE');?></strong>
						</div>
						<div class="mo_boot_col-sm-5 mo_boot_my-2">
							<strong><?php echo JText::_('COM_MINIORANGE_ACTIVE_DIRECTORY_ATTRIBUTE');?></strong>
						</div>
			   		</div>
			   		<div class="mo_boot_row mo_boot_mt-2 mo_boot_my-2" id="mo_ldap_username">
						<div class="mo_boot_col-sm-3 mo_boot_offset-1">
							<strong><?php echo JText::_('COM_MINIORANGE_USERNAME');?></strong>
						</div>
						<div class="mo_boot_col-sm-7">
							<span id="mo_ldap_directory_servers">
                            	<select name="username" id="username"  class="form-select" required>
                                	<option value="" disabled><?php echo JText::_('COM_MINIORANGE_SELECT_USERNAME');?></option>
                                	<option value="samaccountname" <?php if($username == 'samaccountname') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_SAMACCOUNTNAME');?></option>
                                	<option value="cn" <?php if($username == 'cn') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_CN');?></option>
									<option value="sn" <?php if($username == 'sn') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_SN');?></option>
                                	<option value="uid" <?php if($username == 'uid') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_UID');?></option>
                                	<option value="userprincipalname" <?php if($username == 'userprincipalname') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_USERPRINCIPALNAME');?></option>
                                	<option value="mail" <?php if($username == 'mail') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_MAIL');?></option>
									<option value="gidnumber" <?php if($username == 'gidnumber') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_GIDNUMBER');?></option>
									<option value="uidnumber" <?php if($username == 'uidnumber') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_UIDNUMBER');?></option>
								</select>
							</span>
						</div>
			   		</div>
			   		<div class="mo_boot_row mo_boot_mt-2" id="mo_ldap_email">
						<div class="mo_boot_col-sm-3 mo_boot_offset-1">
							<strong><?php echo JText::_('COM_MINIORANGE_EMAIL');?></strong>
						</div>
						<div class="mo_boot_col-sm-7">
							<span id="mo_ldap_directory_servers">
                            	<select name="email" id="email"  class="form-select" required>
                                	<option value="" disabled><?php echo JText::_('COM_MINIORANGE_SELECT_EMAIL');?></option>
                                	<option value="samaccountname" <?php if($email == 'samaccountname') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_SAMACCOUNTNAME');?></option>
                                	<option value="cn" <?php if($email == 'cn') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_CN');?></option>
									<option value="sn" <?php if($email == 'sn') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_SN');?></option>
                                	<option value="uid" <?php if($email == 'uid') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_UID');?></option>
                                	<option value="userprincipalname" <?php if($email == 'userprincipalname') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_USERPRINCIPALNAME');?></option>
                                	<option value="mail" <?php if($email == 'mail') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_MAIL');?></option>
									<option value="gidnumber" <?php if($email == 'gidnumber') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_GIDNUMBER');?></option>
									<option value="uidnumber" <?php if($email == 'uidnumber') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_UIDNUMBER');?></option>
                            	</select>
							</span>
						</div>
			   		</div>
			   		<div class="mo_boot_row mo_boot_mt-2" id="mo_ldap_name">
						<div class="mo_boot_col-sm-3 mo_boot_offset-1">
							<strong><?php echo JText::_('COM_MINIORANGE_NAME');?></strong>
						</div>
						<div class="mo_boot_col-sm-7">
							<span id="mo_ldap_directory_servers">
                        		<select name="name_attr" id="name_attr"  class="form-select" required>
                                	<option value="" disabled><?php echo JText::_('COM_MINIORANGE_SELECT_NAME');?></option>
                                	<option value="samaccountname" <?php if($name == 'samaccountname') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_SAMACCOUNTNAME');?></option>
                                	<option value="cn" <?php if($name == 'cn') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_CN');?></option>
									<option value="sn" <?php if($name == 'sn') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_SN');?></option>
                                	<option value="uid" <?php if($name == 'uid') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_UID');?></option>
                                	<option value="userprincipalname" <?php if($name == 'userprincipalname') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_USERPRINCIPALNAME');?></option>
                                	<option value="mail" <?php if($name == 'mail') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_MAIL');?></option>
									<option value="gidnumber" <?php if($name == 'gidnumber') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_GIDNUMBER');?></option>
									<option value="uidnumber" <?php if($name == 'uidnumber') {echo "selected";} ?>><?php echo JText::_('COM_MINIORANGE_UIDNUMBER');?></option>
								</select>
							</span>
						</div>
			   		</div>
			   		<div class="mo_boot_row mo_boot_my-2">
			   			<div class="mo_boot_col-sm-11 mo_boot_offset-1 mo_boot_my-2">
					   		<input type="submit" <?php if(!$searchFilter){ echo 'disabled';} ?> class="mo_boot_btn mo_ldap_blue_buttons" value="<?php echo JText::_('COM_MINIORANGE_SAVE_ATTRIBUTE_MAPPING');?>"/>
						</div>
			   		</div>
				</form>
				<br>
				<div class="mo_boot_row mo_boot_mt-2 mo_boot_my-2">
				
					<div class="mo_boot_col-sm-10 mo_boot_offset-1">
						<p class="alert alert-secondary mo_boot_my-2"><?php echo JText::_('COM_MINIORANGE_USER_PROFILE_ATTRIBUTE_NOTE');?></p>
						<h5 class="mo_ldap_sub_heading mo_boot_my-4"><?php echo JText::_('COM_MINIORANGE_ADD_JOOMLA_USER_PROFILE_ATTRIBUTES');?>&nbsp;<input type="button" disabled class="mo_boot_btn mo_ldap_blue_buttons" value="+" onclick="mo_ldap_add_user_attibute();" /> <input disabled type="button" class="mo_boot_btn mo_boot_btn-danger" value="-" onclick="mo_ldap_remove_user_attibute();" />
						<a href="#" class="mo_ldap_premium" style="font-size:0.8rem" onclick="mo_ldap_upgrade();"><strong>[<?php echo JText::_('COM_MINIORANGE_PREMIUM');?>]</strong></a></h5>
					</div>
					<div class="mo_boot_col-sm-10 mo_boot_offset-1 mo_boot_mt-2" id="mo_user_profile_attribute_div">
						<div class="mo_boot_row" id="ldap_before_profile_attr_list_upa">
							<div class="mo_boot_col-sm-6">
								<strong><?php echo JText::_('COM_MINIORANGE_USER_PROFILE_ATTRIBUTES');?></strong><br>
								<select class="form-select">
									<?php   			
										echo '<option value="">Select profile attribute</option>';							
										for($i = 0; $i < count($ProfileAttributesList);  $i++) {
											echo	'<option class="mo_boot_px-2" value = "'. $ProfileAttributesList[$i].'">'.$ProfileAttributesList[$i].'</option>';
										} 
									?>
								</select>
							</div>
							<div class="mo_boot_col-sm-6">
								<strong><?php echo JText::_('COM_MINIORANGE_ACTIVE_DIRECTORY_ATTRIBUTE');?></strong><br>
								<select class="form-select">
									<?php   			
										echo '<option value="">Select active directory attribute</option>';							
										for($i = 0; $i < count($ActiveDirectoryAttributes);  $i++) {
											echo	'<option class="mo_boot_px-2" value = "'. $ActiveDirectoryAttributes[$i].'">'.$ActiveDirectoryAttributes[$i].'</option>';
										} 
									?>
								</select>
							</div>
						</div>
					</div>
				</div>	
				<br>
				<div class="mo_boot_row mo_boot_mt-2 mo_boot_my-4">
					<div class="mo_boot_col-sm-10 mo_boot_offset-1">
						<h5 class="mo_ldap_sub_heading"><?php echo JText::_('COM_MINIORANGE_ADD_JOOMLA_USER_FIELD_ATTRIBUTES');?>
						<input type="button" disabled class="mo_boot_btn mo_ldap_blue_buttons" value="+" onclick="mo_ldap_add_user_attibute();" /> 
						<input disabled type="button" class="mo_boot_btn mo_boot_btn-danger" value="-" onclick="mo_ldap_remove_user_attibute();" />
						<a href="#" class="mo_ldap_premium" style="font-size:0.8rem" onclick="mo_ldap_upgrade();"><strong>[<?php echo JText::_('COM_MINIORANGE_PREMIUM');?>]</strong></a></h5>
					</div>
					<div class="mo_boot_col-sm-10 mo_boot_mt-2 mo_boot_my-4 mo_boot_offset-1" id="mo_ldap_user_field_attribute_div">
						<div class="mo_boot_row" id="ldap_before_filed_attr_list_upa">
							<div class="mo_boot_col-sm-6">
								<strong><?php echo JText::_('COM_MINIORANGE_USER_FIELD_ATTRIBUTES');?></strong><br>
								<select  class="form-select">
								<?php   
				
									$fieldNames = MoLdapUtility::moLdapFetchData('#__fields',TRUE,'loadColumn','title');
									$noofroles = count($fieldNames);	
									echo '<option value="">Select field attribute</option>';								
									for($i = 0; $i < $noofroles;  $i++) {
										echo '<option  class="mo_boot_px-2" value = "'. $fieldNames[$i].'">'.$fieldNames[$i].'</option>';
									} 
								?>
								</select>
							</div>
							<div class="mo_boot_col-sm-6">
								<strong><?php echo JText::_('COM_MINIORANGE_ACTIVE_DIRECTORY_ATTRIBUTE');?></strong><br>
								<select class="form-select">
									<?php   			
										echo '<option value="">Select active directory attribute</option>';							
										for($i = 0; $i < count($ActiveDirectoryAttributes);  $i++) {
											echo	'<option class="mo_boot_px-2" value = "'. $ActiveDirectoryAttributes[$i].'">'.$ActiveDirectoryAttributes[$i].'</option>';
										} 
									?>
								</select>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		
		<div class="mo_boot_col-sm-4 mo_boot_row" style="border-left:1px solid var(--body-color);max-height:1164px;overflow-y:scroll">
			<div class="mo_boot_col-sm-12 mo_boot_my-4">
				<h3 class="mo_ldap_heading"><?php echo JText::_('COM_MINIORANGE_USER_DETAILS');?></h3>
			</div>
	
			<div class="mo_boot_col-sm-12">
				<?php if($UserName == "JOHN DOE"){
					echo '<p class="alert alert-secondary">These are default user details. You can get the user details from your Active Directory by clicking the <strong><em>Get User Details</em></strong></p>';
				}
				?>
			</div>
			<div class="mo_boot_col-sm-12 mo_boot_my-2">
				<?php if($UserName == "JOHN DOE"){ $color = 'var(--body-color)';}
					else{ $color='red';} 
					echo '<strong>Username : <span style="color:'.$color.'">'.$UserName.'</span></strong>';
				?>
			</div>
			
			<div class="mo_boot_col-sm-5 mo_boot_offset-1" style="word-wrap: break-word; border: 1px solid var(--body-color); padding: 10px;">
				<strong><?php echo JText::_('COM_MINIORANGE_ATTRIBUTE_NAME');?></strong>
			</div>
			<div class="mo_boot_col-sm-5" style="word-wrap: break-word; border: 1px solid var(--body-color); padding: 10px;">	
				<strong><?php echo JText::_('COM_MINIORANGE_ATTRIBUTE_VALUE');?></strong>
			</div>
			<?php
				
			error_reporting(E_ERROR | E_PARSE);
			$attribute_List = array();
		
			foreach($ActiveDirectoryUserAttributes as $mo_ldap_attribute=>$mo_ldap_key){
				array_push($attribute_List, $mo_ldap_attribute);
			?>
						
			<?php if($mo_ldap_attribute!='memberOf'){ ?>
					<div class="mo_boot_col-sm-5 mo_boot_offset-1" style="word-wrap: break-word; border: 1px solid var(--body-color); padding: 10px;"><?php echo $mo_ldap_attribute; ?></div>
					<div class="mo_boot_col-sm-5" style="word-wrap: break-word; border: 1px solid var(--body-color); padding: 10px;"><?php print_r($mo_ldap_key) ?></div>
			<?php }
				else{?>	
					<div class="mo_boot_col-sm-5 mo_boot_offset-1" style="word-wrap: break-word; border: 1px solid var(--body-color); padding: 10px;"><?php echo $mo_ldap_attribute; ?></div>
					<div class="mo_boot_col-sm-5" style="word-wrap: break-word; border: 1px solid var(--body-color); padding: 10px;">	
						<?php if($mo_ldap_key!="not available")
							foreach($mo_ldap_key as $mo_ldap_keyname=>$mo_ldap_keyvalue){?> 
								<div class="mo_boot_row" style="border: 2px solid #949090;word-wrap: break-word;">
								<div class="mo_boot_col-sm-5 mo_boot_offset-1" style="word-wrap: break-word; border: 1px solid var(--body-color); padding: 10px;"><?php echo $mo_ldap_keyname; ?></div>
								<div class="mo_boot_col-sm-5" style="word-wrap: break-word; border: 1px solid var(--body-color); padding: 10px;"> <?php echo $mo_ldap_keyvalue; ?></div>
								</div>				
							<?php							
							} ?>
						</div>				
						<?php
					}
			}?>

		</div>
	</div>
<?php
}

function moLdapRoleMapping(){

	$moLdapServerConfig = new MoLdapConstants;
	$mapping_value_default = $moLdapServerConfig->getMappingValueDefault();
	$enable_role_mapping = $moLdapServerConfig->getEnableRoleMapping();
	$mapping_count=$moLdapServerConfig->getRoleMappingCount();
	$groups = MoLdapUtility::mo_ldap_get_joomla_groups();
	moStickySupport();
	?> 
	<div class="mo_boot_row mo_ldap_tab_theme">
		<form class="mo_boot_col-sm-12" action="<?php echo JRoute::_('index.php?option=com_miniorange_dirsync&view=accountsetup&task=accountsetup.moLdapSaveRolemapping'); ?>" method="post" name="adminForm">
		
			<div class="mo_boot_col-sm-12 mo_boot_mt-2 mo_boot_py-2">	
				<h3 class="mo_ldap_heading"><?php echo JText::_('COM_MINIORANGE_GROUP_MAPPING');?></h3>
			</div>
			<div class="mo_boot_col-sm-11 mo_boot_offset-1 mo_boot_mt-2">
			<input id="enable_role_mapping" class="mo_boot_mt-4" type="checkbox" name="enable_role_mapping" value="1" <?php if($enable_role_mapping==1) echo "checked"; ?> style=" margin-right: 10px;"> <?php echo JText::_('COM_MINIORANGE_ENABLE_GROUP_MAPPING');?>
			</div>
			<div class="mo_boot_col-sm-11 mo_boot_offset-1 mo_boot_mt-2">
				<input type="checkbox" name="disable_update_existing_users_role" value="1" style="margin-right: 10px;" disabled> <?php echo JText::_('COM_MINIORANGE_NO_UPDATE_EXISTING_USER');?>
				<a href="#" class="mo_ldap_premium mo_ldap_premium_features" onclick="mo_ldap_upgrade();"><strong> [<?php echo JText::_('COM_MINIORANGE_PREMIUM');?>]</strong></a>
			</div>
			<div class="mo_boot_col-sm-11 mo_boot_offset-1 mo_boot_mt-2">
				<input type="checkbox" name="disable_update_existing_users_role" value="1" style="margin-right: 10px;" disabled> <?php echo JText::_('COM_MINIORANGE_MAP_SUPER_USERS');?>
				<a href="#" class="mo_ldap_premium mo_ldap_premium_features" onclick="mo_ldap_upgrade();"><strong> [<?php echo JText::_('COM_MINIORANGE_PREMIUM');?>]</strong></a>
			</div>
			<div class="mo_boot_col-sm-11 mo_boot_offset-1 mo_boot_mt-2">
				<div class="mo_boot_row" id="ldapgroup">
					<div class="mo_boot_col-sm-5 mo_boot_mx-4">
						<p class="mo_boot_px-1"><?php echo JText::_('COM_MINIORANGE_SELECT_DEFAULT_GROUPS');?></p>
					</div>
					<div class="mo_boot_col-sm-3" id="mo_ldap_grp_defaultgrp">
						<select class="form-select" name="mapping_value_default" id="default_group_mapping"> 
							<?php
								$noofroles = 0;
								foreach ($groups as $group) {
									if($group[4] != 'Super Users' || $group[4] != 'Public' || $group[4] != 'Guest'){
										if($mapping_value_default ==  $group[0])
											echo '<option selected="selected" value = "'. $group[0].'">'.$group[4].'</option>';
										else
											echo '<option  value = "'. $group[0].'">'.$group[4].'</option>';
									}
								}									
							?>
						</select>
					</div>
				</div>
			</div>
	
			<div class="mo_boot_row mo_boot_my-3 mo_boot_mx-1">
				<div class="mo_boot_col-sm-11 mo_boot_offset-1">
					<input class="mo_boot_btn mo_ldap_blue_buttons"  value="<?php echo JText::_('COM_MINIORANGE_SAVE_GROUP_MAPPING');?>" type="submit">
			    </div>
			</div>
		</form>
		
		<form class="mo_boot_col-sm-11 mo_boot_offset-1" action="" method="post" name="adminForm">						

			<div class="mo_boot_col-sm-12 mo_boot_my-4 ">
				<h5 class="mo_ldap_sub_heading">Map User Groups&nbsp;<input type="button" disabled class="mo_boot_btn mo_ldap_blue_buttons" value="+" onclick="mo_ldap_add_user_attibute();" /> <input disabled type="button" class="mo_boot_btn mo_boot_btn-danger" value="-" onclick="mo_ldap_remove_user_attibute();" />
				<a href="#" class="mo_ldap_premium mo_ldap_premium_features" onclick="mo_ldap_upgrade();"><strong>[<?php echo JText::_('COM_MINIORANGE_PREMIUM');?>]</strong></a></h5>
				
				<p class='alert alert-secondary'>
					<?php echo JText::_('COM_MINIORANGE_GROUP_MAPPING_NOTE1');?> 
					<a href="#" class="mo_ldap_premium mo_ldap_premium_features" onclick="mo_ldap_upgrade();"> <strong>[<?php echo JText::_('COM_MINIORANGE_PREMIUM');?>]</strong></a> 
					<?php echo JText::_('COM_MINIORANGE_GROUP_MAPPING_NOTE2');?>
				</p>
			</div>
			<div class="mo_boot_col-sm-12 mo_boot_mt-2" id="ldap_role_mapping_table">
				<div class="mo_boot_row">
					<div class="mo_boot_col-sm-6">
						<strong style="font-size:14px"><?php echo JText::_('COM_MINIORANGE_LDAP_GROUP_NAME');?></strong>
					</div>
					<div class="mo_boot_col-sm-6">
						<strong style="font-size:14px"><?php echo JText::_('COM_MINIORANGE_JOOMLA_GROUP');?></strong>
					</div>
				</div>
				<div class="mo_boot_row mo_boot_mt-2">
					<div class="mo_boot_col-sm-6">
						<input class="form-control mo_ldap_test_mapping" id="mo_ldap_table_textbox" type="text" name="mapping_key"
							value="" placeholder="<?php echo JText::_('COM_MINIORANGE_LDAP_GROUP_NAME_PLACEHOLDER');?>" />
					</div>
					<div class="mo_boot_col-sm-6" id="mo_ldap_grp_defaultgrp">
						<select  class="form-select" name="mapping_value" id="joomla_roles_list disabled">
						<?php
							$noofroles = 0;
							foreach ($groups as $group) {
								if($group[4] != 'Super Users' || $group[4] != 'Public'|| $group[4] != 'Guest'){								
									echo '<option  value = "'. $group[0].'">'.$group[4].'</option>';
								}
							}
						?>
						</select>
					</div>
				</div>
			</div>

			<div class="mo_boot_col-sm-12 mo_boot_py-3">
				<div class="mo_boot_row mo_boot_mt-2">
					<div class="mo_boot_col-sm-6 mo_boot_py-2">
						<p style="font-size:14px;font-weight:bold;"><?php echo JText::_('COM_MINIORANGE_LDAP_GROUP_ATTRIBUTE_NAME');?></p>
					</div>
					<div class="mo_boot_col-sm-6">
						<input class="form-control" type="text" name="mapping_memberof_attribute" required="true" placeholder="<?php echo JText::_('COM_MINIORANGE_LDAP_GROUP_ATTRIBUTE_NAME');?>" value="<?php echo JText::_('COM_MINIORANGE_MEMBEROF');?>" disabled >
					</div>
				</div>
			</div>
		</form>
	</div>	
	<?php	
}

function moLdapLicensingPlan(){
	
	$useremail = MoLdapUtility::moLdapFetchData('#__miniorange_ldap_customer',array('id'=>'1'),'loadAssoc')	;
    if (isset($useremail)) $user_email = $useremail['email'];
    else $user_email = "xyz";
	$circle_icon = '
        <svg class="min-w-[8px] min-h-[8px]" width="8" height="8" viewBox="0 0 18 18" fill="none">
            <circle id="a89fc99c6ce659f06983e2283c1865f1" cx="9" cy="9" r="7" stroke="rgb(99 102 241)" stroke-width="4"></circle>
        </svg>
    ';
?>
	

	<div class="mo_boot_row mo_ldap_tab_theme">
		<div class="mo_boot_col-sm-12 mo_boot_my-4">
 			<div id="mo_ldap_liciensing_table_wrapper">
				<h2 class="mo_ldap_sub_heading mo_boot_mx-4" id="mo_ldap_target_license"><?php echo JText::_('COM_MINIORANGE_FEATURE_COMPARISON');?><a class="mo-button primary" style="float:right" href="index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=mo_ldap_trial_demo&query_type=trial">Free Trial</a></h2>
			</div>
    		<br>

	   		<div id="mo_ldap_pricing_page" class="mo_ldap_pricing_page mo_boot_my-2">
                <div class="mo_ldap_pricing_snippet_grid">
                 	<div class="mo_ldap_pricing_card" >
          				<h5><?php echo JText::_('COM_MINIORANGE_FEATURE_COMPARISION_FREE_PLAN');?></h5>
						<h1>$0</h1>
                        <ul class="mo_boot_mt-mo-4 grow" >
                            <li class="mo_ldap_feature_snippet"><span><?php echo $circle_icon;?></span><span style='font-size:14px;line-height:1.75rem'>Auto-Register users</span></li>
                            <li class="mo_ldap_feature_snippet"><span><?php echo $circle_icon;?></span><span style='font-size:14px;line-height:1.75rem'>100 user authentications</span.</li> 
                            <li class="mo_ldap_feature_snippet"><span><?php echo $circle_icon;?></span><span style='font-size:14px;line-height:1.75rem'>Basic Profile Mapping</span></li>    
							<li class="mo_ldap_feature_snippet"><span><?php echo $circle_icon;?></span><span style='font-size:14px;line-height:1.75rem'>Authenticate users from both Active Directory and Joomla</span></li>    
							<li class="mo_ldap_feature_snippet"><span><?php echo $circle_icon;?></span><span style='font-size:14px;line-height:1.75rem'>Support for LDAPS connection</span></li>    
							<li class="mo_ldap_feature_snippet"><span><?php echo $circle_icon;?></span><span style='font-size:14px;line-height:1.75rem'>Ignore LDAPS certificate</span></li>    
							<li class="mo_ldap_feature_snippet"><span><?php echo $circle_icon;?></span><span style='font-size:14px;line-height:1.75rem'>Export plugin configuration</span></li>                           
                        </ul>
                        <button class="mo-button primary" onclick="window.open('https://extensions.joomla.org/extension/access-a-security/ldap-integration-with-active-directory-and-openldap-ntlm-kerberos-login/')">Current Plan</button>
                    </div>

                    <div class="mo_ldap_pricing_card">
						<h5><?php echo JText::_('COM_MINIORANGE_FEATURE_COMPARISION_BASIC_PLAN');?></h5>
       					<h1 class="">$149*<span style="font-size:1rem; margin-top:5%"><i> /instance</i></span></h1>
						<p class="mo_boot_font-weight-bold">All free plan features +</p>
                    	<ul class="mt-mo-4 grow" >
                            <li class="mo_ldap_feature_snippet"><span><?php echo $circle_icon;?></span><span style='font-size:14px;line-height:1.75rem'>Unlimited user authentications</span></li> 
                            <li class="mo_ldap_feature_snippet"><span><?php echo $circle_icon;?></span><span style='font-size:14px;line-height:1.75rem'>Import plugin configuration</span></li> 
                            <li class="mo_ldap_feature_snippet"><span><?php echo $circle_icon;?></span><span style='font-size:14px;line-height:1.75rem'>Redirect LDAP users to custom url after login</span></li>                           
                        </ul>
                        <button class="mo-button primary" onclick=" window.open('https://portal.miniorange.com/initializepayment?requestOrigin=joomla_ldap_basic_plan')">Upgrade Now</button>
                    </div>

                    <div class="mo_ldap_pricing_card premium">
       					<h5><?php echo JText::_('COM_MINIORANGE_FEATURE_COMPARISION_PREMIUM_PLAN');?></h5>
 						<h1 class="text-white">$449<span style="font-size:1rem; margin-top:5%"><i> /instance</i></span></h1>
						<p class="mo_boot_font-weight-bold">All basic plan features +</p>
                        <ul class="mt-mo-4 grow" >
                            <li class="mo_ldap_feature_snippet">
                                <span style="margin-top: 0.2rem; margin-left: -8px;" >
                                    <svg width="22" height="21" viewBox="0 0 22 21" fill="none" xmlns="http://www.w3.org/2000/svg">
                                        <path d="M3 6C3 4.8 8.33333 2.83333 11 2C12 2 19 5 19 6C19 11 18 15 11 18C2 14.5 3 7.5 3 6Z" fill="white" stroke="white"/>
                                        <path fill-rule="evenodd" clip-rule="evenodd" d="M12.21 2.98146C11.4396 2.65466 10.5604 2.65466 9.79005 2.98146L5.20871 4.92506C4.12255 5.38585 3.43422 6.40399 3.5005 7.49026C3.66198 10.1364 4.14481 11.9666 5.06269 13.4607C5.98172 14.9566 7.37667 16.1811 9.49324 17.5489C10.402 18.1362 11.6003 18.137 12.5065 17.5499C14.6269 16.1764 16.0112 14.9404 16.9216 13.4422C17.8318 11.9446 18.3072 10.1206 18.4831 7.50512C18.5566 6.41041 17.8665 5.38122 16.7731 4.91735L12.21 2.98146ZM9.2316 1.78208C10.3574 1.30446 11.6426 1.30445 12.7684 1.78208L17.3316 3.71797C18.9069 4.38631 19.9686 5.90183 19.8552 7.58915C19.6724 10.3092 19.1695 12.359 18.111 14.1008C17.0528 15.8422 15.4781 17.2112 13.2786 18.636C11.9048 19.5259 10.0953 19.523 8.72239 18.6358C6.53236 17.2205 4.94531 15.8642 3.87659 14.1246C2.80671 12.3831 2.29602 10.3228 2.12783 7.56658C2.02547 5.88909 3.08612 4.38926 4.65027 3.72568L9.2316 1.78208Z" fill="white"/>
                                        <path fill-rule="evenodd" clip-rule="evenodd" d="M14.2027 7.38112C14.4885 7.61979 14.5174 8.03438 14.2674 8.30714L11.6366 11.177C11.0713 11.7937 10.0976 11.8763 9.42728 11.3644L7.82052 10.1374C7.52403 9.91103 7.47596 9.49806 7.71315 9.21504C7.95035 8.93203 8.38299 8.88614 8.67948 9.11255L10.2862 10.3395C10.382 10.4127 10.5211 10.4009 10.6019 10.3128L13.2326 7.44286C13.4826 7.17009 13.917 7.14246 14.2027 7.38112Z" fill="black"/>
                                    </svg>                                    
                                </span>
                                <span style='font-size:14px;line-height:1.75rem'>Authenticate users from Multiple LDAP Search Bases</span>
                            </li>  
							<li class="mo_ldap_feature_snippet">  <span style="margin-top: 0.2rem; margin-left: -8px;" >
                                    <svg width="22" height="21" viewBox="0 0 22 21" fill="none" xmlns="http://www.w3.org/2000/svg">
                                        <path d="M3 6C3 4.8 8.33333 2.83333 11 2C12 2 19 5 19 6C19 11 18 15 11 18C2 14.5 3 7.5 3 6Z" fill="white" stroke="white"/>
                                        <path fill-rule="evenodd" clip-rule="evenodd" d="M12.21 2.98146C11.4396 2.65466 10.5604 2.65466 9.79005 2.98146L5.20871 4.92506C4.12255 5.38585 3.43422 6.40399 3.5005 7.49026C3.66198 10.1364 4.14481 11.9666 5.06269 13.4607C5.98172 14.9566 7.37667 16.1811 9.49324 17.5489C10.402 18.1362 11.6003 18.137 12.5065 17.5499C14.6269 16.1764 16.0112 14.9404 16.9216 13.4422C17.8318 11.9446 18.3072 10.1206 18.4831 7.50512C18.5566 6.41041 17.8665 5.38122 16.7731 4.91735L12.21 2.98146ZM9.2316 1.78208C10.3574 1.30446 11.6426 1.30445 12.7684 1.78208L17.3316 3.71797C18.9069 4.38631 19.9686 5.90183 19.8552 7.58915C19.6724 10.3092 19.1695 12.359 18.111 14.1008C17.0528 15.8422 15.4781 17.2112 13.2786 18.636C11.9048 19.5259 10.0953 19.523 8.72239 18.6358C6.53236 17.2205 4.94531 15.8642 3.87659 14.1246C2.80671 12.3831 2.29602 10.3228 2.12783 7.56658C2.02547 5.88909 3.08612 4.38926 4.65027 3.72568L9.2316 1.78208Z" fill="white"/>
                                        <path fill-rule="evenodd" clip-rule="evenodd" d="M14.2027 7.38112C14.4885 7.61979 14.5174 8.03438 14.2674 8.30714L11.6366 11.177C11.0713 11.7937 10.0976 11.8763 9.42728 11.3644L7.82052 10.1374C7.52403 9.91103 7.47596 9.49806 7.71315 9.21504C7.95035 8.93203 8.38299 8.88614 8.67948 9.11255L10.2862 10.3395C10.382 10.4127 10.5211 10.4009 10.6019 10.3128L13.2326 7.44286C13.4826 7.17009 13.917 7.14246 14.2027 7.38112Z" fill="black"/>
                                    </svg>                                    
                                </span></span><span style='font-size:14px;line-height:1.75rem'>Group mapping from Active Directory to Joomla</span></li> 
                            <li class="mo_ldap_feature_snippet">  <span style="margin-top: 0.2rem; margin-left: -8px;" >
                                    <svg width="22" height="21" viewBox="0 0 22 21" fill="none" xmlns="http://www.w3.org/2000/svg">
                                        <path d="M3 6C3 4.8 8.33333 2.83333 11 2C12 2 19 5 19 6C19 11 18 15 11 18C2 14.5 3 7.5 3 6Z" fill="white" stroke="white"/>
                                        <path fill-rule="evenodd" clip-rule="evenodd" d="M12.21 2.98146C11.4396 2.65466 10.5604 2.65466 9.79005 2.98146L5.20871 4.92506C4.12255 5.38585 3.43422 6.40399 3.5005 7.49026C3.66198 10.1364 4.14481 11.9666 5.06269 13.4607C5.98172 14.9566 7.37667 16.1811 9.49324 17.5489C10.402 18.1362 11.6003 18.137 12.5065 17.5499C14.6269 16.1764 16.0112 14.9404 16.9216 13.4422C17.8318 11.9446 18.3072 10.1206 18.4831 7.50512C18.5566 6.41041 17.8665 5.38122 16.7731 4.91735L12.21 2.98146ZM9.2316 1.78208C10.3574 1.30446 11.6426 1.30445 12.7684 1.78208L17.3316 3.71797C18.9069 4.38631 19.9686 5.90183 19.8552 7.58915C19.6724 10.3092 19.1695 12.359 18.111 14.1008C17.0528 15.8422 15.4781 17.2112 13.2786 18.636C11.9048 19.5259 10.0953 19.523 8.72239 18.6358C6.53236 17.2205 4.94531 15.8642 3.87659 14.1246C2.80671 12.3831 2.29602 10.3228 2.12783 7.56658C2.02547 5.88909 3.08612 4.38926 4.65027 3.72568L9.2316 1.78208Z" fill="white"/>
                                        <path fill-rule="evenodd" clip-rule="evenodd" d="M14.2027 7.38112C14.4885 7.61979 14.5174 8.03438 14.2674 8.30714L11.6366 11.177C11.0713 11.7937 10.0976 11.8763 9.42728 11.3644L7.82052 10.1374C7.52403 9.91103 7.47596 9.49806 7.71315 9.21504C7.95035 8.93203 8.38299 8.88614 8.67948 9.11255L10.2862 10.3395C10.382 10.4127 10.5211 10.4009 10.6019 10.3128L13.2326 7.44286C13.4826 7.17009 13.917 7.14246 14.2027 7.38112Z" fill="black"/>
                                    </svg>                                    
                                </span><span style='font-size:14px;line-height:1.75rem'>User Profile and Field Mapping</span></li>  
                            <li class="mo_ldap_feature_snippet">  <span style="margin-top: 0.2rem; margin-left: -8px;" >
                                    <svg width="22" height="21" viewBox="0 0 22 21" fill="none" xmlns="http://www.w3.org/2000/svg">
                                        <path d="M3 6C3 4.8 8.33333 2.83333 11 2C12 2 19 5 19 6C19 11 18 15 11 18C2 14.5 3 7.5 3 6Z" fill="white" stroke="white"/>
                                        <path fill-rule="evenodd" clip-rule="evenodd" d="M12.21 2.98146C11.4396 2.65466 10.5604 2.65466 9.79005 2.98146L5.20871 4.92506C4.12255 5.38585 3.43422 6.40399 3.5005 7.49026C3.66198 10.1364 4.14481 11.9666 5.06269 13.4607C5.98172 14.9566 7.37667 16.1811 9.49324 17.5489C10.402 18.1362 11.6003 18.137 12.5065 17.5499C14.6269 16.1764 16.0112 14.9404 16.9216 13.4422C17.8318 11.9446 18.3072 10.1206 18.4831 7.50512C18.5566 6.41041 17.8665 5.38122 16.7731 4.91735L12.21 2.98146ZM9.2316 1.78208C10.3574 1.30446 11.6426 1.30445 12.7684 1.78208L17.3316 3.71797C18.9069 4.38631 19.9686 5.90183 19.8552 7.58915C19.6724 10.3092 19.1695 12.359 18.111 14.1008C17.0528 15.8422 15.4781 17.2112 13.2786 18.636C11.9048 19.5259 10.0953 19.523 8.72239 18.6358C6.53236 17.2205 4.94531 15.8642 3.87659 14.1246C2.80671 12.3831 2.29602 10.3228 2.12783 7.56658C2.02547 5.88909 3.08612 4.38926 4.65027 3.72568L9.2316 1.78208Z" fill="white"/>
                                        <path fill-rule="evenodd" clip-rule="evenodd" d="M14.2027 7.38112C14.4885 7.61979 14.5174 8.03438 14.2674 8.30714L11.6366 11.177C11.0713 11.7937 10.0976 11.8763 9.42728 11.3644L7.82052 10.1374C7.52403 9.91103 7.47596 9.49806 7.71315 9.21504C7.95035 8.93203 8.38299 8.88614 8.67948 9.11255L10.2862 10.3395C10.382 10.4127 10.5211 10.4009 10.6019 10.3128L13.2326 7.44286C13.4826 7.17009 13.917 7.14246 14.2027 7.38112Z" fill="black"/>
                                    </svg>                                    
                                </span><span style='font-size:14px;line-height:1.75rem'>Custom Search Filter</span></li> 
                        </ul>
                        <button class="mo-button premium"  onclick=" window.open('https://portal.miniorange.com/initializepayment?requestOrigin=joomla_ldap_premium_plan')">Upgrade Now</button>
                    </div>

                    <div class="mo_ldap_pricing_card" style="border:none;">
         				<h5><?php echo JText::_('COM_MINIORANGE_FEATURE_COMPARISION_ENTERPRISE_PLAN');?></h5>
  						<h1>$649<span style="font-size:1rem; margin-top:5%"><i> /instance</i></span></h1>
						<p class="mo_boot_font-weight-bold">All premium plan features +</p>
                        <ul class="mt-mo-4 grow">
                            <li class="mo_ldap_feature_snippet"><span><?php echo $circle_icon;?></span><span style='font-size:14px;line-height:1.75rem'>Support for Multiple LDAP Server</span></li> 
                            <li class="mo_ldap_feature_snippet"><span><?php echo $circle_icon;?></span><span style='font-size:14px;line-height:1.75rem'>Detailed user authentication report</span></li>  
                            <li class="mo_ldap_feature_snippet"><span><?php echo $circle_icon;?></span><span style='font-size:14px;line-height:1.75rem'>Access to all premium add-ons</span>
								<ul>
									<li class="mo_boot_mx-4" style="font-size:14px;line-height:1.75rem"><span style="font-weight:bold;color:#263C59;padding:2px;">-</span> NTLM/Kerberos SSO</li>
									<li class="mo_boot_mx-4" style="font-size:14px;line-height:1.75rem"><span style="font-weight:bold;color:#263C59;padding:2px;font-size:14px;line-height:1.75rem">-</span>Import Users from Active Directory</li>
									<li class="mo_boot_mx-4" style="font-size:14px;line-height:1.75rem"><span style="font-weight:bold;color:#263C59;padding:2px;font-size:14px;line-height:1.75rem">-</span>Sync users from Joomla to Active Directory</li>
								</ul>
							</li>
                        </ul>
                        <button class="mo-button primary" onclick="window.open('https://www.miniorange.com/contact')">Upgrade Now</a>
                    </div>
                </div>
			</div>


		<div class="mo_boot_col-sm-12 mo_boot_my-2" >
			<p class="mo_boot-my-2"><?php echo JText::_('COM_MINIORANGE_BASIC_SUBSCRIPTION');?></p></div>
		
		<div class="mo_boot_my-4">
			<h2 class="mo_ldap_sub_heading mo_boot_my-4 mo_boot_mx-4"><?php echo JText::_('COM_MINIORANGE_UPGRADE_TO_PREMIUM');?></h2>        
			<section id="mo_ldap_section-steps" >
				<div class="mo_boot_col-sm-12 mo_boot_row ">
					<div class=" mo_boot_col-sm-6 mo_ldap_works-step" style="padding-left: 40px">
						<div style="padding-top:2px"><strong>1</strong></div>
						<p><?php echo JText::_('COM_MINIORANGE_UPGRADE_STEP1');?></p>
					</div>
					<div class="mo_boot_col-sm-6 mo_ldap_works-step">
						<div style="padding-top:2px"><strong>4</strong></div>
						<p><?php echo JText::_('COM_MINIORANGE_UPGRADE_STEP4');?></p>
					</div>            
				</div>

				<div class="mo_boot_col-sm-12 mo_boot_row">
					<div class=" mo_boot_col-sm-6 mo_ldap_works-step" style="padding-left: 40px">
						<div style="padding-top:2px"><strong>2</strong></div>
						<p> <?php echo JText::_('COM_MINIORANGE_UPGRADE_STEP2-1');?> 
						<a href="<?php echo JURI::base()?>index.php?option=com_miniorange_dirsync&view=accountsetup&tab-panel=accountsetup">
						<?php echo JText::_('COM_MINIORANGE_HERE');?> </a>
						<?php echo JText::_('COM_MINIORANGE_UPGRADE_STEP2-2');?></p>
					</div>
					<div class="mo_boot_col-sm-6 mo_ldap_works-step">
						<div style="padding-top:2px"><strong>5</strong></div>
						<p><?php echo JText::_('COM_MINIORANGE_UPGRADE_STEP5');?> </p>
					</div>         
				</div>

				<div class="mo_boot_col-sm-12 mo_boot_row ">
					<div class="mo_boot_col-sm-6 mo_ldap_works-step" style="padding-left: 40px">
						<div style="padding-top:2px"><strong>3</strong></div>
						<p><?php echo JText::_('COM_MINIORANGE_UPGRADE_STEP3');?></p>
					</div>
					<div class=" mo_boot_col-sm-6 mo_ldap_works-step">
						<div style="padding-top:2px"><strong>6</strong></div>
						<p><?php echo JText::_('COM_MINIORANGE_UPGRADE_STEP6');?></p>
					</div>       
				</div> 
			</section>        
		</div>
	
        <h2 class="mo_ldap_sub_heading mo_boot_mx-4 mo_boot_my-2">Frequently Asked Questions</h2> 
		<div class="mo_boot_mx-4">
		<div class="mo_boot_row">
			<div class="mo_boot_col-sm-6">
				<h3 class="mo_ldap_faq_page"><?php echo JText::_('COM_MINIORANGE_FAQ1');?></h3>
				<div class="mo_ldap_faq_body">
					<p><?php echo JText::_('COM_MINIORANGE_FAQ1_DETAILS');?></p>
				</div>
				<hr class="mo_ldap_hr_line">
			</div>
		
			<div class="mo_boot_col-sm-6">
				<h3 class="mo_ldap_faq_page"><?php echo JText::_('COM_MINIORANGE_FAQ2');?></h3>
				<div class="mo_ldap_faq_body">
					<p><?php echo JText::_('COM_MINIORANGE_FAQ2_DETAILS');?></p>
				</div>
				<hr class="mo_ldap_hr_line">
			</div>
		</div>
		<div class="mo_boot_row">
			<div class="mo_boot_col-sm-6">
				<h3 class="mo_ldap_faq_page"><?php echo JText::_('COM_MINIORANGE_FAQ3');?></h3>
				<div class="mo_ldap_faq_body">
					<p><?php echo JText::_('COM_MINIORANGE_FAQ3_DETAILS');?></p>
				</div>
				<hr class="mo_ldap_hr_line">
			</div>

			<div class="mo_boot_col-sm-6">
				<h3 class="mo_ldap_faq_page"><?php echo JText::_('COM_MINIORANGE_FAQ4');?></h3>
				<div class="mo_ldap_faq_body">
					<p><?php echo JText::_('COM_MINIORANGE_FAQ4_DETAILS');?></p>
				</div>
				<hr class="mo_ldap_hr_line">
			</div>
		</div>
		<div class="mo_boot_row">	
			<div class="mo_boot_col-sm-6">
				<h3 class="mo_ldap_faq_page"><?php echo JText::_('COM_MINIORANGE_FAQ5');?></h3>
				<div class="mo_ldap_faq_body">
					<p><?php echo JText::_('COM_MINIORANGE_FAQ5_DETAILS');?></p>
				</div>
				<hr class="mo_ldap_hr_line">
			</div>
			<div class="mo_boot_col-sm-6">
				<h3 class="mo_ldap_faq_page"><?php echo JText::_('COM_MINIORANGE_FAQ6');?></h3>
				<div class="mo_ldap_faq_body">
					<?php echo JText::_('COM_MINIORANGE_FAQ6_DETAILS');?>
				</div>
				<hr class="mo_ldap_hr_line">
            </div>
       	</div>
						</div>
		<script>
			var test = document.querySelectorAll('.mo_ldap_faq_page');
			test.forEach(function(header) {
				header.addEventListener('click', function() {
					var body = this.nextElementSibling;
					body.style.display = body.style.display === 'none' || body.style.display =="" ? 'block' : 'none';
  				});
			});
		</script>
				
    </div>


	
</div>	
<?php
}


function moLdapShowAddon(){
	?>
	<div class="mo_boot_row mo_ldap_tab_theme">	
		<section class="mo_boot_mx-4">
    		<div class="mo_addon_title">
        		<h3 class="mo_ldap_sub_heading mo_boot_mt-4">Premium Addons</h3>
    		</div>
    		<div class="mo_boot_row mo_boot_mt-4">
        		<div class="mo_addon_tab mo_boot_col-sm-3">
            		<button class="mo_addon_tab_btn active mo_ldap_blue_buttons" onclick="openTab(event, 'mo_addon1')" id="defaultTab">Search Staff from LDAP Directory</button>
            		<button class="mo_addon_tab_btn mo_ldap_blue_buttons" onclick="openTab(event, 'mo_addon3')">Auto Login/ NTLM SSO</button>
            		<button class="mo_addon_tab_btn mo_ldap_blue_buttons" onclick="openTab(event, 'mo_addon4')">Import Users from Active Directory</button>
            		<button class="mo_addon_tab_btn mo_ldap_blue_buttons" onclick="openTab(event, 'mo_addon5')">Password Sync</button>
            		<button class="mo_addon_tab_btn mo_ldap_blue_buttons" onclick="openTab(event, 'mo_addon7')">User sync from Joomla to Active Directory</button>
        		</div>

        		<div class="addon_tab-box mo_boot_col-sm-9">
            		<div class="addon_tab_content" id="mo_addon1" style="display:block">
                		<h4 class="mo_ldap_heading">Search Staff from LDAP Directory</h4>
                		<p>You may search and show users from your Active Directory onto your Joomla page with
                    	the Search Staff from LDAP Directory add-on. Consider an example in which you need to get in touch
							with an employee of the company but just know their name and no other way to reach them. The
							employee's contact information will be displayed to you once you do a search for the employee using
							the custom form.</p>
						<button class="mo_boot_btn mo_ldap_blue_buttons" onclick="window.open('https://plugins.miniorange.com/joomla-ldap-search-directory')">Learn More</button>
					</div>

					<div class="addon_tab_content" id="mo_addon3" style="display:none">
						<h4 class="mo_ldap_heading">Auto Login/ NTLM SSO</h4>
						<p>By using miniOrange Auto Login/NTLM SSO add-on, you will be automatically logged in
							when you use your domain credentials to log in to your Joomla site. As a result, you won't have to
							enter your credentials repeatedly to login to your Joomla site.</p>
						<button class="mo_boot_btn mo_ldap_blue_buttons" onclick="window.open('https://developers.miniorange.com/docs/joomla_ldap/ntlm-authentication')">Learn More</button>
					</div>

					<div class="addon_tab_content" id="mo_addon4" style="display:none">
						<h4 class="mo_ldap_heading">Import Users from Active Directory</h4>
						<p>miniOrange Import Users from Joomla to Active Directory add-on for Joomla allows
							organizations to easily import and synchronize their LDAP/Active Directory users to their Joomla
							site. This saves time and efforts of organizations by eliminating the need for manual user
							registration and updation on your Joomla site. This ensures that your Joomla database is always
							up-to-date with the latest user information from the LDAP/Active Directory.</p>
						<button class="mo_boot_btn mo_ldap_blue_buttons" onclick="window.open('https://developers.miniorange.com/docs/joomla_ldap/directory-sync')">Learn More</button>
					</div>

					<div class="addon_tab_content" id="mo_addon5" style="display:none">
						<h4 class="mo_ldap_heading">Password Sync</h4>
						<p>Passwords can be automatically updated in the LDAP Directory whenever a user changes
							or resets his or her password using the miniOrange Password Sync with LDAP Server add-on. By doing
							this, a user can have the same password across their Joomla website and their Active Directory
							account information.</p>
						<button class="mo_boot_btn mo_ldap_blue_buttons" onclick="window.open('https://developers.miniorange.com/docs/joomla_ldap/joomla-ldap-handbook')">Learn More</button>
					</div>

					<div class="addon_tab_content" id="mo_addon7" style="display:none">
						<h4 class="mo_ldap_heading">User sync from Joomla to Active Directory</h4>
						<p>miniOrange User Sync from Joomla to Active Directory add-on for Joomla allows
							organizations to easily import and synchronize their Joomla user details to their LDAP/Active
							Directory users. </p>
						<button class="mo_boot_btn mo_ldap_blue_buttons" onclick="window.open('https://developers.miniorange.com/docs/joomla_ldap/joomla-ldap-handbook')">Learn More</button>
					</div>
        		</div>
    		</div>
		</section>
	</div>

<?php
}


function moLdapShowAdvAddons(){
	?>
<div >
	
	<div class="mo_boot_p-3">
		<div class="mo_boot_row">
			<div class="mo_boot_mx-2 mo_boot_col-sm-2">
				<img src="<?php echo JUri::base();?>/components/com_miniorange_dirsync/assets/images/miniorange_i.ico" alt="miniorange"> 
			</div>
        	<strong class="mo_boot_col-sm-9"><?php echo JText::_('COM_MINIORANGE_AUTO_LOGIN');?></strong>
		</div>
		<div class="mo_boot_py-3 mo_boot_text-center">
			<hr><p><?php echo JText::_('COM_MINIORANGE_AUTO_LOGIN_DETAILS');?></p>
			<input type="button" class="mo_boot_btn mo_boot_btn-primary mo_boot_px-3 mo_boot_col-sm-5" style="background-color:#001b4c;"  onclick="window.open('https://www.miniorange.com/contact')" target="_blank" value="<?php echo JText::_('COM_MINIORANGE_INTERESTED');?>"/>
        </div>
    </div>


	<div class="mo_boot_my-4 mo_boot_p-3">
		<div class="mo_boot_row">
			<div class="mo_boot_mx-2 mo_boot_col-sm-2">
        		<img src="<?php echo JUri::base();?>/components/com_miniorange_dirsync/assets/images/miniorange_i.ico" alt="miniorange">
			</div>
			<strong class="mo_boot_col-sm-9"><?php echo JText::_('COM_MINIORANGE_PROFILE_SYNC');?></strong>	
		</div>	
		<div class="mo_boot_py-3 mo_boot_text-center">
			<hr>
			<p><?php echo JText::_('COM_MINIORANGE_PROFILE_SYNC_DETAILS');?></p>               
			<input type="button" class="mo_boot_btn mo_boot_btn-primary mo_boot_px-3 mo_boot_col-sm-5" style="background-color:#001b4c;"  onclick="window.open('https://www.miniorange.com/contact')" target="_blank" value="<?php echo JText::_('COM_MINIORANGE_INTERESTED');?>"/>
        </div>
    </div>
	
	<div class="mo_boot_my-4 mo_boot_p-3">
		<div class="mo_boot_row">
			<div class="mo_boot_mx-2 mo_boot_col-sm-2">
				<img src="<?php echo JUri::base();?>/components/com_miniorange_dirsync/assets/images/miniorange_i.ico" alt="miniorange">
			</div> 
			<strong class="mo_boot_py-2 mo_boot_col-sm-8"><?php echo JText::_('COM_MINIORANGE_PASSWORD_SYNC');?></strong>
		</div>
		<div class="mo_boot_py-3 mo_boot_text-center">
			<hr>
			<p><?php echo JText::_('COM_MINIORANGE_PASSWORD_SYNC_DETAILS');?></p>
			<input type="button" class="mo_boot_btn mo_boot_btn-primary mo_boot_px-3 mo_boot_col-sm-5" style="background-color:#001b4c;"  onclick="window.open('https://www.miniorange.com/contact')" target="_blank" value="<?php echo JText::_('COM_MINIORANGE_INTERESTED');?>"/>
        </div>
    </div>
	
	
	<div class="mo_boot_my-4 mo_boot_p-3">
		<div class="mo_boot_row">
			<div class="mo_boot_col-sm-2 mo_boot_mx-2">
				<img src="<?php echo JUri::base();?>/components/com_miniorange_dirsync/assets/images/miniorange_i.ico" alt="miniorange">
			</div>
			<strong class="mo_boot_py-2 mo_boot_col-sm-8" ><?php echo JText::_('COM_MINIORANGE_IMPORT_AD_USERS');?></strong>
		</div> 
		<div class="mo_boot_py-3 mo_boot_text-center">
			<hr>
			<p><?php echo JText::_('COM_MINIORANGE_IMPORT_AD_USERS_DETAILS');?></p>
			<input type="button" class="mo_boot_btn mo_boot_btn-primary mo_boot_px-3 mo_boot_col-sm-5" style="background-color:#001b4c;"  onclick="window.open('https://www.miniorange.com/contact')" target="_blank" value="<?php echo JText::_('COM_MINIORANGE_INTERESTED');?>"/>
        </div>
    </div>
</div>
<?php
}


function moLdapSupportTab(){
	global $license_tab_link;

	$current_user = JFactory::getUser();
	$customer_details = MoLdapUtility::moLdapFetchData('#__miniorange_ldap_customer',array('id'=>'1'),'loadAssoc')	;
	$admin_email = isset($customer_details['email']) ? $customer_details['email'] : '';
    if ($admin_email == '') $admin_email = $current_user->email;
	$admin_phone = $customer_details['admin_phone'];
	$strJsonFileContents = file_get_contents(__DIR__.'/../../../assets/json/timezones.json'); 
	$timezoneJsonArray = json_decode($strJsonFileContents, true);
	$get = JFactory::getApplication()->input->get->getArray();

	$type_of_query = isset($get['query_type']) ? $get['query_type'] : "";
	
    ?>
    <div class="mo_boot_row mo_ldap_tab_theme">
        <div class="mo_boot_col-sm-12 mo_boot_mt-4">
            <h3 class="mo_ldap_heading"><?php echo JText::_('COM_MINIORANGE_SUPPORT_FEATURES');?></h3>
        </div>
        <div class="mo_boot_col-sm-12 mo_boot_mt-2">
			<form name="mo_ldap_contact_us" method="post" action="<?php echo JRoute::_('index.php?option=com_miniorange_dirsync&view=accountsetup&task=accountsetup.moLdapContactUs');?>">
          		<div class="mo_boot_col-sm-12 mo_boot_mt-2">
                	<div class="mo_boot_row mo_boot_mt-2">
                        <div class="mo_boot_col-sm-3 mo_boot_offset-1">
                            <?php echo JText::_('COM_MINIORANGE_EMAIL');?><span style="color: red;">*</span>
                        </div>
                        <div class="mo_boot_col-sm-6">
							<input type="email" class="form-control" id="mo_ldap_query_email" name="mo_ldap_query_email" value="<?php echo $admin_email; ?>" placeholder="<?php echo JText::_('COM_MINIORANGE_SUPPORT_EMAIL');?>" required />	
                        </div>
                    </div>
                    <div class="mo_boot_row mo_boot_mt-2">
                        <div class="mo_boot_col-sm-3 mo_boot_offset-1"> <?php echo JText::_('COM_MINIORANGE_PHONE_NUMBER');?></div>
                        <div class="mo_boot_col-sm-6">
							<input type="tel" pattern="[\+]\d{11,14}|[\+]\d{1,4}([\s]{0,1})(\d{0}|\d{9,10})" class="form-control" name="mo_ldap_query_phone" id="mo_ldap_query_phone" value="<?php echo $admin_phone; ?>" placeholder="<?php echo JText::_('COM_MINIORANGE_SUPPORT_PHONE');?>"/>
                        </div>
                    </div>

					<div class="mo_boot_row mo_boot_mt-2">
                        <div class="mo_boot_col-sm-3 mo_boot_offset-1">
                            <?php echo JText::_('COM_MINIORANGE_ISSUE');?>:<span class="mo_ldap_highlight">*</span>
                        </div>
            	        <div class="mo_boot_col-sm-6">
                	        <select class="form-select" name="mo_ldap_setup_call_issue" required>
                    	        <option value="" disabled><?php echo JText::_('COM_MINIORANGE_SELECT_ISSUE_TYPE');?></option>
                        	    <option id="mo_ldap_sso_setup_issue" <?php if($type_of_query == 'setup_issue') echo 'selected';?>><?php echo JText::_('COM_MINIORANGE_SSO_SETUP_ISSUE');?></option>
                            	<option id="mo_ldap_configuration_issues" <?php if($type_of_query == 'configuration') echo 'selected';?>><?php echo JText::_('COM_MINIORANGE_CONFIGURATION_ISSUES');?></option>
								<option id="mo_ldap_use_case_discussion" <?php if($type_of_query == 'user_case') echo 'selected';?>><?php echo JText::_('COM_MINIORANGE_USECASE_DISCUSSION');?></option>
								<option id="mo_ldap_trial_request" <?php if($type_of_query == 'trial') echo 'selected';?>><?php echo JText::_('COM_MINIORANGE_TRIAL_REQUEST');?></option>
                            	<option id="mo_ldap_other_issue" <?php if($type_of_query == 'other') echo 'selected';?>><?php echo JText::_('COM_MINIORANGE_OTHER');?></option>
                        	</select>
						</div>
                    </div>
                    <div class="mo_boot_row mo_boot_mt-2">
                        <div class="mo_boot_col-sm-3 mo_boot_offset-1"><?php echo JText::_('COM_MINIORANGE_QUERY');?>:<span style="color: red;">*</span></div>
                        <div class="mo_boot_col-sm-6">
							<textarea id="mo_ldap_query" class = "mo_boot_px-3 form-control" name="mo_ldap_query" style="height:150px !important" placeholder="<?php echo JText::_('COM_MINIORANGE_SUPPORT_QUERY');?>" required></textarea>
                        </div>
                    </div>
					<div class="mo_boot_row mo_boot_mt-2">
						<div class="mo_boot_col-sm-3 mo_boot_offset-1"></div>
						<div class="mo_boot_col-sm-6">
							<input id="mo_ldap_query_withconfig"  type="checkbox" name="mo_ldap_query_withconfig" value="1" > <?php echo JText::_('COM_MINIORANGE_SEND_CONFIGURATION');?>
						</div>
					</div>
                    <div class="mo_boot_row mo_boot_my-4 mo_boot_text-center">
                        <div class="mo_boot_col-sm-12">
                            <input type="submit" name="send_query"  value="<?php echo JText::_('COM_MINIORANGE_SUBMIT_QUERY');?>" class="mo_boot_btn mo_ldap_blue_buttons"/>
                        </div>
                    </div>
                </div>
            </form>          
        </div>
    </div>
<?php
}