<?php
/**
 * @package    miniOrange
 * @subpackage Plugins
 * @license    GNU/GPLv3
 * You should have received a copy of the GNU General Public License
 * along with miniOrange LDAP plugin.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 defined('_JEXEC') or die('Restricted access');
 require_once JPATH_ADMINISTRATOR.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_miniorange_dirsync'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'mo_ldap_utility.php';
 require_once JPATH_ADMINISTRATOR.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_miniorange_dirsync'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'dirsync_ldap_config.php';
 require_once JPATH_ADMINISTRATOR.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_miniorange_dirsync'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'dirsync_handler.php';
 require_once JPATH_ADMINISTRATOR.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_miniorange_dirsync'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'mo_ldap_constants.php';
 if (defined('_JEXEC')) {
	 
	 
	/**
	 * This block of code is not used.
	 */
	class plgauthenticationmoldap extends JPlugin
	{
		/**
		 * This method should handle any authentication and report back to the subject
		 * 
		 *
		 * @access    public
		 * @param     array     $credentials    Array holding the user credentials ('username' and 'password')
		 * @param     array     $options        Array of extra options
		 * @param     object    $response       Authentication response object
		 * @return    boolean
		 */
		 
		
	function onUserAuthenticate( $credentials, $options, &$response )
	{
		
		$app=JFactory::getApplication('site');
		$uname=trim($credentials['username']);	
		$upasswd=isset($credentials['password'])? $credentials['password']: '';

		if($upasswd=='' || $upasswd==' '){
					
			$response->status=JAuthentication::STATUS_FAILURE;
			$app->enqueueMessage('Kindly please enter the password.', 'warning');
			return;
		}

		$ldapServerConfig=new MoLdapConstants;
		$user_auth='false';
		
		if($ldapServerConfig->getEnableLdap()=='ch'){


			$validatefilter=JFilterInput::getInstance();
			$username=$validatefilter->clean($uname, 'username');
			$password=$upasswd; //NOT VALIDATING PASSWORDS AS THEY MIGHT CONTAIN SPECIAL CHARACTERS

			$serverName=$ldapServerConfig->getServerURL();
			$ldapHostname=filter_var($serverName, FILTER_SANITIZE_STRING);
			$ldapServerConfig->setLdapConnObject(self::getConnection($ldapHostname));

			if($ldapServerConfig->getLdapConnObject()){
					
				$searchFilter=$ldapServerConfig->getSearchFilter();
				$filterName=ldap_escape($username, "", LDAP_ESCAPE_FILTER);
				$searchFilter='(&(objectClass=*)('.$searchFilter.'=?))';
				$filter=str_replace('?', $filterName, $searchFilter);		
				$userSearchResult=null;
				$entry=null;
				$info=null;


				$bind=@ldap_bind($ldapServerConfig->getLdapConnObject(), $ldapServerConfig->getBindDN(), $ldapServerConfig->getBindDNPassword());			
				$err=ldap_error($ldapServerConfig->getLdapConnObject());
										
				$user_auth="";
				$extended_error=ldap_error($ldapServerConfig->getLdapConnObject());
				$error_number=ldap_errno($ldapServerConfig->getLdapConnObject());
				$errormessage=MoLdapUtility::mo_ldap_error_type($error_number);

				if($errormessage!='COM_MINIORANGE_SUCCESSFUL_CONNECTION')
					return $errormessage;

				if(strtolower($err)=='success'){

					if(ldap_search($ldapServerConfig->getLdapConnObject(), $ldapServerConfig->getSearchBase(), $filter)){
					
						$userSearchResult=ldap_search($ldapServerConfig->getLdapConnObject(), $ldapServerConfig->getSearchBase(), $filter,['*','+']);
						$info=ldap_first_entry($ldapServerConfig->getLdapConnObject(), $userSearchResult);
						$entry=ldap_get_entries($ldapServerConfig->getLdapConnObject(), $userSearchResult);
							
						if($info)
							$user_auth=@ldap_bind($ldapServerConfig->getLdapConnObject(), $entry[0]['dn'],$upasswd);
								
						if($user_auth=='true'){
							$ssoresult=MoLdapUtility::moLdapFetchData('#__miniorange_ldap_customer',array('id'=>'1'),'loadAssoc')	;		
									
							Mo_Dirsync_Hanlder::getResource();	
								
						    $test=base64_decode($ssoresult['sso_var']);
							$test=$test + 10;
							$test2=base64_decode($ssoresult['sso_test']);
				
							if ($test2 > $test) {
								self::moLdapUpdate();
							}
							
							$test=base64_decode(empty($ssoresult['sso_test'])?base64_encode(0):$ssoresult['sso_test']);			
							$sso_test=$test + 1;
							$sso_test=base64_encode($sso_test);

							$databaseName='#__miniorange_ldap_customer';
							$fields=array('sso_test'=>$sso_test);
							$conditions=array('id'=>'1');
							MoLdapUtility::moLdapUpdateData($databaseName,$fields,$conditions);
						}		
	
						if($user_auth=='true'){
							$response->type='Ldap';
							$response->error_message='';
						
							//IF ATTRIBUTE MAPPING IS CONFIGURED
							$response->username=self::moLdapAttributeMapping($entry,$ldapServerConfig->getUsernameAttribute(),'string');
							$response->email=self::moLdapAttributeMapping($entry,$ldapServerConfig->getEmailAttribute(),'email');
							$response->fullname=self::moLdapAttributeMapping($entry,$ldapServerConfig->getNameAttribute(),'string');
					
							if(empty($response->email)){
									
								$app->enqueueMessage('<strong>MOLDAP A01:</strong>: User email not retrieved. Contact your administrator for more details.', 'warning');
								return;
							}

							if(!filter_var($response->email, FILTER_VALIDATE_EMAIL)){
								$app->enqueueMessage('<strong>MOLDAP A02:</strong> User email attribute that you have contacted is incorrect. Contact your administrator for more details.', 'warning');
								return;
							}
							
							if(empty($response->username)){
								$app->enqueueMessage('<strong>MOLDAP A03:</strong> Username not retrieved. Contact your administrator for more details.', 'warning');
								return;
							}

							if(empty($response->fullname)){
								$app->enqueueMessage("<strong>MOLDAP A04:</strong> User's name not retrieved. Contact your administrator for more details.", 'warning');
								return;
							}


							//CHECK FOR SAME EMAIL DIFFERENT USERNAME
							$userEmailExists=MoLdapUtility::moLdapFetchData('#__users',array('email'=> $response->email),'loadAssoc',array('email', 'username'),);
					
							if(!empty($userEmailExists) && $userEmailExists['username'] !=$response->username){
							
								$app->enqueueMessage('<strong>MOLDAP A05:</strong> Username and Email mismatch. Contact your administrator for more details.', 'warning');
								return;
							}

							$userUsernameExists=MoLdapUtility::moLdapFetchData('#__users',array('username'=> $response->email),'loadAssoc',array('email', 'username'),);
							if(!empty($userUsernameExists) && $userUsernameExists['email'] !=$response->email){
						
								$app->enqueueMessage('<strong>MOLDAP A06:</strong> Username and Email mismatch. Contact your administrator for more details.', 'warning');
								return;
							}

							$response->status=JAuthentication::STATUS_SUCCESS;
							return;
						}
					}
				}
			}
		}else{
				
		    $response->status=JAuthentication::STATUS_FAILURE;
			$app->enqueueMessage('<strong>MOLDAP W01</strong>: You have not enabled LDAP login. Please contact administrator.','warning');
		}
	}


	public static function getConnection($serverName){

		$ldapconn=ldap_connect($serverName);
		if ( version_compare(PHP_VERSION, '5.3.0') >=0 ) {
			ldap_set_option($ldapconn, LDAP_OPT_NETWORK_TIMEOUT, 5);
		}

		ldap_set_option($ldapconn, LDAP_OPT_PROTOCOL_VERSION, 3);
		ldap_set_option($ldapconn, LDAP_OPT_REFERRALS, 0);
		$ldapServerConfig=new MoLdapConstants;
		$ignoreLdaps=$ldapServerConfig->getIgnoreCertificateState();
		$enableTls = $ldapServerConfig->getEnableTls();

		if($ignoreLdaps=='ch')
			ldap_set_option(NULL, LDAP_OPT_X_TLS_REQUIRE_CERT, 0);
		
		if($enableTls=='ch')
			ldap_start_tls($ldapconn);

		return $ldapconn;
	}
			
	
	public static function moLdapUpdate(){

		$db=JFactory::getDbo(); 
		$query=$db->getQuery(true);
								
		$fields=array(
			$db->quoteName('enabled') . '='.$db->quote(0),					
		);				 
								
		$conditions=array(
			$db->quoteName('element') . '='.$db->quote('moldap').'OR'. $db->quoteName('element') . '=' . $db->quote('miniorangedirsync'),
		);				 
		$query->update($db->quoteName('#__extensions'))->set($fields)->where($conditions);
		$db->setQuery($query);	
		$db->execute();
	}

	public static function moLdapAttributeMapping($entry, $attributeMap,$attributeType){
		
		$validatefilter=JFilterInput::getInstance();
		$userAttribute="";
        if(isset($attributeMap)){					 
			if(isset($entry[0][$attributeMap][0]) && !empty($entry[0][$attributeMap][0]))
			  	$userAttribute=$validatefilter->clean($entry[0][$attributeMap][0], $attributeType);  
			else if(isset($entry[0]['userprincipalname'][0]) && !empty($entry[0]['userprincipalname'][0]))
			    $userAttribute=$validatefilter->clean($entry[0]['userprincipalname'][0], $attributeType);
			else if(isset($entry[0]['mail'][0]) && !empty($entry[0]['mail'][0]))
			    $userAttribute=$validatefilter->clean($entry[0]['mail'][0], $attributeType);
		}else{
		    if(isset($entry[0]['userprincipalname'][0]) && !empty($entry[0]['userprincipalname'][0]))
			    $userAttribute=$validatefilter->clean($entry[0]['userprincipalname'][0], $attributeType);
			else if(isset($entry[0]['mail'][0]) && !empty($entry[0]['mail'][0]))
			    $userAttribute=$validatefilter->clean($entry[0]['mail'][0], $attributeType);
		}   
		return $userAttribute;

	}

	public static function onUserAfterLogin(){
		
		$app=JFactory::getApplication();
		$post=JFactory::getApplication()->input->post->getArray();
		
		if(isset($post['username'])){
			
			//DB for gettting User Profile Attributes
			$ldapServerConfig=new MoLdapConstants;

			if($ldapServerConfig->getEnableLdap()=='ch'){
				
				$validatefilter=JFilterInput::getInstance();
				$uname=$validatefilter->clean($post['username'], 'username');
				$users=JFactory::getUser();	
					
				$serverName=$ldapServerConfig->getServerURL();
				$ldapHostname=filter_var($ldapServerConfig->getServerURL(), FILTER_SANITIZE_STRING);
				$ldapconn=self::getConnection($ldapHostname);
					
				if($ldapconn){
				
					$searchFilter=$ldapServerConfig->getSearchFilter();
					$searchFilter='(&(objectClass=*)('.$searchFilter.'=?))';
					$filterName=ldap_escape($uname, "", LDAP_ESCAPE_FILTER);
					$filter=str_replace('?', $filterName, $searchFilter);
					$userSearchResult=null;
					$entry=null;
					$info=null;

					$bind=@ldap_bind($ldapconn, $ldapServerConfig->getBindDN(),  $ldapServerConfig->getBindDNPassword());				
					$err=ldap_error($ldapconn);
					$extended_error=ldap_error($ldapconn);
					$error_number=ldap_errno($ldapconn);
					$errormessage=MoLdapUtility::mo_ldap_error_type($error_number);
	
					if($errormessage!='COM_MINIORANGE_SUCCESSFUL_CONNECTION')
						return $errormessage;

					if(ldap_search($ldapconn, $ldapServerConfig->getSearchBase(), $filter)){
						$userSearchResult=ldap_search($ldapconn, $ldapServerConfig->getSearchBase(), $filter,['*','+']);	
						$info=ldap_first_entry($ldapconn, $userSearchResult);
						$entry=ldap_get_entries($ldapconn, $userSearchResult);						
										
						if($info){

						   	$uname=self::moLdapAttributeMapping($entry,$ldapServerConfig->getUsernameAttribute(),'string');
							$uemail=self::moLdapAttributeMapping($entry,$ldapServerConfig->getEmailAttribute(),'email');
							$jname=self::moLdapAttributeMapping($entry,$ldapServerConfig->getNameAttribute(),'string');
						
							$databaseName='#__users';
							$fields=array('email'=>$uemail, 'name'=>$jname, 'username'=>$uname);
							$conditions=array('id'=>$users->id);
							MoLdapUtility::moLdapUpdateData($databaseName,$fields,$conditions);

							// Group Mapping
							if($ldapServerConfig->getEnableRoleMapping()){
									
								if(isset($users->groups[8]))
									$flag=0;
								else
									$flag=1;
						
								if($ldapServerConfig->getEnableRoleMapping() && $flag){
									JUserHelper::addUserToGroup($users->id, $ldapServerConfig->getMappingValueDefault());		
							
								}
						
								foreach($users->groups as $existinggroup){
									if($existinggroup!=$ldapServerConfig->getMappingValueDefault() && $existinggroup!=$users->groups[7] && $existinggroup!=$users->groups[8])
										JUserHelper::removeUserFromGroup($users->id, $existinggroup);
								}
							}			
						}			
					}
				}
			}
		}	
	}
 }
}
?>